
jQuery(function ($) {
    if (typeof plupload !== 'undefined' && typeof QTCUploader !== 'undefined') {
        var uploader = new plupload.Uploader(QTCUploader);
        uploader.init();
        uploader.bind('FilesAdded', function (up) {
            up.start();
            $('#qtc_gallery_spinner').show();
        });
        uploader.bind('FileUploaded', function (up, file, res) {
            var hidespinner = (uploader.total.queued < 1) ? function () {
                $('#qtc_gallery_spinner').hide();
            } : function () {

            };
            if (typeof res.response !== 'undefined') {
                qtc_gallery.get_thumbnail(res.response, hidespinner);
            }
        });
    } else {
        $('#qtc-plupload-browse-button').hide();
    }

    var file_frame,
            qtc_gallery = {
                admin_thumb_ul: '',
                init: function () {
                    this.admin_thumb_ul = $('#qtc_gallery_thumbs');
                    this.admin_thumb_ul.sortable({
                        placeholder: 'qtc_gallery_placeholder'
                    });
                    this.admin_thumb_ul.on('click', '.qtc_gallery_remove', function () {
                        $(this).parent().fadeOut(100, function () {
                            $(this).remove();
                        });
                        return false;
                    });

                    $('#qtc_gallery_upload_button').on('click', function (event) {
                        event.preventDefault();
                        if (file_frame) {
                            file_frame.open();
                            return;
                        }

                        file_frame = wp.media.frames.file_frame = wp.media({
                            title: jQuery(this).data('uploader_title'),
                            button: {
                                text: jQuery(this).data('uploader_button_text'),
                            },
                            multiple: true
                        });

                        file_frame.on('select', function () {
                            var images = file_frame.state().get('selection').toJSON(),
                                    length = images.length;
                            for (var i = 0; i < length; i++) {
                                qtc_gallery.get_thumbnail(images[i]['id']);
                            }
                        });
                        file_frame.open();
                    });

                    $('#qtc_gallery_add_attachments_button').on('click', function () {
                        var included = [];
                        $('#qtc_gallery_thumbs input[type=hidden]').each(function (i, e) {
                            included.push($(this).val());
                        });
                        qtc_gallery.get_all_thumbnails(POST_ID, included);
                    });

                    $('#qtc_gallery_delete_all_button').on('click', function () {
                        if (confirm('Are you sure you want to delete all the images in the design?')) {
                            qtc_gallery.admin_thumb_ul.empty();
                        }
                        return false;
                    });
                },
                get_thumbnail: function (id, cb) {
                    cb = cb || function () {
                    };
                    var data = {
                        action: 'qtc_gallery_get_thumbnail',
                        imageid: id
                    };
                    $('#qtc_gallery_spinner').show();
                    jQuery.post(ajaxurl, data, function (response) {
                        qtc_gallery.admin_thumb_ul.append(response);
                        cb();
                        $('#qtc_gallery_spinner').hide();
                    });
                },
                get_all_thumbnails: function (post_id, included) {
                    var data = {
                        action: 'qtc_gallery_get_all_thumbnail',
                        post_id: post_id,
                        included: included
                    };
                    $('#qtc_gallery_spinner').show();
                    $.post(ajaxurl, data, function (response) {
                        qtc_gallery.admin_thumb_ul.append(response);
                        $('#qtc_gallery_spinner').hide();
                    });
                }
            };
    qtc_gallery.init();
});