<?php

/*
  Plugin Name: Options Sympathy
  Plugin URI: http://qtcmedia.com
  Description: Show all shortcode for sympathy theme
  Version: 1.1
  Author: QTCMedia Team
  Author URI: http://qtcmedia.com
 */

// don't load directly
if (!defined('ABSPATH')) {
    die('-1');
}
define('SYMPATHY_PLUGIN_URL', plugin_dir_url(__FILE__));

define('SYMPATHY_PLUGIN_PATH', plugin_dir_path(__FILE__));
define('SYMPATHY_PLUGIN_OPTIONS_DIR', SYMPATHY_PLUGIN_PATH . 'qtc-options/');
define('SYMPATHY_PLUGIN_OPTIONS_URL', SYMPATHY_PLUGIN_URL . 'qtc-options/');
define('SYMPATHY_PLUGIN_IMPORT_DIR', SYMPATHY_PLUGIN_PATH . 'import/');
define('SYMPATHY_PLUGIN_IMPORT_URL', SYMPATHY_PLUGIN_URL . 'import/');

add_filter('widget_text', 'do_shortcode');

/* ---------------------------------------------------------------------------
 * Loads the Options Panel
 * --------------------------------------------------------------------------- */
require_once (SYMPATHY_PLUGIN_OPTIONS_DIR . 'index.php');
require_once (SYMPATHY_PLUGIN_IMPORT_DIR . 'import.php');
require_once (SYMPATHY_PLUGIN_PATH . 'inc/galleries/index.php');

if (!function_exists('sympathy_insert_shortcode')) {

    function sympathy_insert_shortcode($tag, $func) {
        add_shortcode($tag, $func);
    }

}
if (!function_exists('sympathy_custom_reg_post_type')) {

    function sympathy_custom_reg_post_type($post_type, $args = array()) {
        register_post_type($post_type, $args);
    }

}
if (!function_exists('sympathy_custom_reg_taxonomy')) {

    function sympathy_custom_reg_taxonomy($taxonomy, $object_type, $args = array()) {
        register_taxonomy($taxonomy, $object_type, $args);
    }

}



// Add custom post type and shortcode, widget
$template = get_option('template');
if ($template == 'sympathy') {

    // Meta Option ------------------------------------------------------------
    require_once( 'meta-options/meta-option.php');
    require_once( 'meta-options/template-option.php');

    //shortcode
    require_once('theme-shortcodes.php');
    // Widget ----------------------------------------------------------------------*/
    require_once( 'widgets/photo-gallery.php' );
    require_once( 'widgets/lastest-news.php' );
    require_once( 'widgets/tabs-news.php' );
    require_once( 'widgets/client.php' );
    if (class_exists('Woocommerce')) {
        require_once( 'widgets/product-featured.php' );
    }

    $sympathy_smof_data = get_option('sympathy_smof_data');
    if (isset($sympathy_smof_data['qtc_enable_team']) && $sympathy_smof_data['qtc_enable_team']) {
        require_once('custom-post-types/team.php');
    }
    if (isset($sympathy_smof_data['qtc_enable_client']) && $sympathy_smof_data['qtc_enable_client']) {
        require_once('custom-post-types/client.php');
    }
} else {
    require_once('custom-post-types/team.php');
    require_once('custom-post-types/client.php');
}
if (!function_exists('remove_redux_messages')) {

    function remove_redux_messages() {
        if (class_exists('ReduxFramework')) {
            remove_action('admin_notices', array(get_redux_instance('sympathy_smof_data'), '_admin_notices'), 99);
        }
    }

}
if (!function_exists('redux_disable_dev_mode_plugin')) {

    function redux_disable_dev_mode_plugin($redux) {
        if ($redux->args['opt_name'] != 'redux_demo') {
            $redux->args['dev_mode'] = false;
            $redux->args['forced_dev_mode_off'] = false;
        }
    }

    add_action('redux/construct', 'redux_disable_dev_mode_plugin');
}

add_action('init', 'remove_redux_messages');
