(function ($) {
    "use strict";
    jQuery(document).ready(function ($) {
        $(".tabs-menu a").click(function (event) {
            event.preventDefault();
            $(this).parent().addClass("current");
            $(this).parent().siblings().removeClass("current");
            var tab = $(this).attr("href");
            $(".tab-content").not(tab).css("display", "none");
            $(tab).fadeIn();
        });
        $('select[name="_qtc_header_position"]').change(function () {
            var value = $(this).val();
            if (value === 'top') {
                $('#page_header_enable_menu').show();
            } else {
                $('#page_header_enable_menu').hide();
            }
        });
        $('select[name="_qtc_footer_layout"]').change(function () {
            var value = $(this).val();
            var i;
            for (i = 1; i <= 5; ++i) {
                if (i <= value) {
                    $('.footer_widget_' + i).show();
                } else {
                    $('.footer_widget_' + i).hide();
                }
            }
        });



        $('#post-formats-select input').change(checkformat);
        $('.wp-post-format-ui .post-format-options > a').click(checkformat);
        videoType();
        audioType();
        checkformat();
        quoteType();

        $("#sympathy_post_quote_type").change(function () {
            quoteType();
        });

        $("#sympathy_post_video_source").change(function () {
            videoType();
        });

        $("#sympathy_post_audio_type").change(function () {
            audioType();
        });

        function checkformat() {
            "use strict";
            var formats = ["gallery", "link", "image", "quote", "video", "audio", "chat"];
            var format = $('#post-formats-select input:checked').attr('value');
            var i = 0;
            for (i = 0; i < formats.length; i++) {
                if (formats[i] == format) {
                    $("#sympathy_post_" + format + "").css('display', 'block');
                } else {
                    $("#sympathy_post_" + formats[i] + "").css('display', 'none');
                }
            }
        }

        function quoteType() {
            "use strict";
            switch ($("#sympathy_post_quote_type").val()) {
                case 'custom':
                    $("#post_quote_custom").css('display', 'block');
                    break;
                default:
                    $("#post_quote_custom").css('display', 'none');
                    break;
            }
        }

        function audioType() {
            "use strict";
            switch ($("#sympathy_post_audio_type").val()) {
                case '':
                    $("#sympathy_metabox_field_post_audio_url").css('display', 'none');
                    break;
                case 'content':
                    $("#sympathy_metabox_field_post_audio_url").css('display', 'none');
                    break;
                default:
                    $("#sympathy_metabox_field_post_audio_url").css('display', 'block');
                    break;
            }
        }
        function videoType() {
            "use strict";
            switch ($("#sympathy_post_video_source").val()) {
                case '':
                    $("#sympathy_video_setting").css('display', 'none');
                    break;
                case 'post':
                    $("#sympathy_video_setting").css('display', 'none');
                    break;
                case 'media':
                    $("#sympathy_metabox_field_post_video_type").css('display', 'block');
                    $("#sympathy_metabox_field_post_video_url").css('display', 'block');
                    $("#sympathy_metabox_field_post_preview_image").css('display', 'block');
                    $("#sympathy_metabox_field_post_video_youtube").css('display', 'none');
                    $("#sympathy_metabox_field_post_video_vimeo").css('display', 'none');
                    $("#sympathy_video_setting").css('display', 'block');
                    break;
                case 'youtube':
                    $("#sympathy_metabox_field_post_video_type").css('display', 'none');
                    $("#sympathy_metabox_field_post_video_url").css('display', 'none');
                    $("#sympathy_metabox_field_post_preview_image").css('display', 'none');
                    $("#sympathy_metabox_field_post_video_youtube").css('display', 'block');
                    $("#sympathy_metabox_field_post_video_vimeo").css('display', 'none');
                    $("#sympathy_video_setting").css('display', 'block');
                    break;
                case 'vimeo':
                    $("#sympathy_metabox_field_post_video_type").css('display', 'none');
                    $("#sympathy_metabox_field_post_video_url").css('display', 'none');
                    $("#sympathy_metabox_field_post_preview_image").css('display', 'none');
                    $("#sympathy_metabox_field_post_video_youtube").css('display', 'none');
                    $("#sympathy_metabox_field_post_video_vimeo").css('display', 'block');
                    $("#sympathy_video_setting").css('display', 'block');
                    break;
            }
        }
    });
})(jQuery);