<?php
/**
 * Button
 *
 * @package Sympathy
 * @author QTC Media
 * @link http://qtcmedia.com
 */
/* -------------------Box Donation---------------------- */
sympathy_insert_shortcode('sympathy_box_donation', 'sympathy_box_donation_template');
if (!function_exists('sympathy_box_donation_template')):

    function sympathy_box_donation_template($atts, $content) {
        global $sympathy_smof_data, $wp_query;
        extract(shortcode_atts(array(
            'column' => 3,
            'image_1' => '',
            'amount_donation_1' => '$0,0',
            'content_1' => '',
            'image_2' => '',
            'amount_donation_2' => '$0,0',
            'content_2' => '',
            'image_3' => '',
            'amount_donation_3' => '$0,0',
            'content_3' => '',
            'image_4' => '',
            'amount_donation_4' => '$0,0',
            'content_4' => '',
            'pst_left' => 0,
            'position' => 'default',
            'pst_right' => 0,
            'el_class' => '',
                        ), $atts));
        $rand_grid = rand(5, 12315646131);
        $i = 0;
        $id = md5(time() . ' ' . $rand_grid);
        $column_css = '';
        $numb_col = 0;
        switch ($column) {
            case 'one_col' : {
                    $column_css = 'one-column';
                    $numb_col = 1;
                    break;
                }
            case 'two_col': {
                    $column_css = 'two-column';
                    $numb_col = 2;
                    break;
                }
            case 'three_col': {
                    $column_css = 'three-column';
                    $numb_col = 3;
                    break;
                }
            case 'fourth_col': {
                    $column_css = 'four-column';
                    $numb_col = 4;
                    break;
                }
        }
        ob_start();
        ?>
        
        <div id="box-donation-loop-<?php echo esc_attr($id); ?>" data-query="" class="crt-box-donation col-<?php echo esc_attr($column_css); ?> pts-<?php echo esc_attr($position); ?> <?php echo esc_attr($el_class); ?> js-loop js-el clear">
            <div class="crt-content-box-donation position-<?php echo esc_attr($position); ?>" <?php if ($position == 'left') { ?> style="left:<?php echo esc_attr($pst_left); ?>px;" <?php } elseif ($position == 'right') { ?> style="right:<?php echo esc_attr($pst_right); ?>px;" <?php }else{} ?>>
                <?php
                for ($x = 0; $x < $numb_col; $x++) {
                    $i = $i + 1;
                    $amount_donation = 'amount_donation_' . $i;
                    $content_box = 'content_' . $i;
                    $image = 'image_' . $i;
                    $active = ($i == 2 || $i == 4) ? 'active' : '';
                    $link_img = apply_filters('ult_get_img_single', $$image, 'url');
                    ?>                
                    <div class="<?php echo esc_attr($column_css); ?> box-item-<?php echo esc_attr($i + 1); ?> crt-box-donation-item ">
                        <div class="content-box-donation-item">
                            <?php if (!empty($link_img)) { ?>
                                <div class="img-box-donation">
                                    <img src="<?php echo esc_attr($link_img); ?>" alt="<?php echo esc_attr($$content_box); ?>"/>
                                </div>
                            <?php } ?>
                            <div class="item-holder <?php echo esc_attr($active); ?>" <?php if (!empty($image_1) || !empty($image_2) || !empty($image_3) || !empty($image_4)) { ?> style="height:100px;" <?php } else { ?> style="height:150px;" <?php } ?>>
                                <div class="item-des">
                                    <h2 class="amount-donation"><?php echo esc_attr($$amount_donation); ?></h2>
                                    <?php if (!empty($$content_box)): ?>
                                        <p><?php echo esc_attr($$content_box); ?></p>
                                    <?php endif; ?>
                                </div>                                
                            </div>   
                        </div>
                    </div>                 
                <?php } ?>                                   
                <div class="clearboth"></div>
            </div>
        </div>
        <?php
        return ob_get_clean();
    }

endif;

add_action('vc_before_init', 'sympathy_vc_box_donation');
if (!function_exists('sympathy_vc_box_donation')) {

    function sympathy_vc_box_donation() {
        vc_map(array(
            "name" => esc_html__("Box Donation", 'sympathy'),
            "base" => "sympathy_box_donation",
            "class" => "sympathy_box_donation",
            "category" => esc_html__('QTCThemes', 'sympathy'),
            'icon' => get_template_directory_uri() . "/images/icon/grid2.png",
            'description' => esc_html__('Adds a Box Donation.', 'sympathy'),
            "params" => array(
                array(
                    "type" => "dropdown",
                    "heading" => esc_html__("How many Column?", "sympathy"),
                    "param_name" => "column",
                    "value" => array(
                        esc_html__('1 Column', 'sympathy') => 'one_col',
                        esc_html__('2 Columns', 'sympathy') => 'two_col',
                        esc_html__('3 Columns', 'sympathy') => 'three_col',
                        esc_html__('4 Columns', 'sympathy') => 'fourth_col',
                    ),
                    "description" => esc_html__("How many columns would you like to appear in one row?", "sympathy"),
                ),
                array(
                    "type" => "ult_img_single",
                    "heading" => __("Image 1", "sympathy"),
                    "param_name" => "image_1",
                    'value' => '',
                    "description" => __("Either upload a new, or choose an existing image from your media library", "sympathy"),
                    "dependency" => array(
                        'element' => "column",
                        'value' => array(
                            'one_col',
                            'two_col',
                            'three_col',
                            'fourth_col',
                        )
                    ),
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Amount Donation 1", "sympathy"),
                    "param_name" => "amount_donation_1",
                    "value" => "$0,0",
                    "description" => esc_html__("", "sympathy"),
                    "dependency" => array(
                        'element' => "column",
                        'value' => array(
                            'one_col',
                            'two_col',
                            'three_col',
                            'fourth_col',
                        )
                    ),
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Content 1", "sympathy"),
                    "param_name" => "content_1",
                    "value" => "",
                    "description" => esc_html__("", "sympathy"),
                    "dependency" => array(
                        'element' => "column",
                        'value' => array(
                            'one_col',
                            'two_col',
                            'three_col',
                            'fourth_col',
                        )
                    ),
                ),
                array(
                    "type" => "ult_img_single",
                    "heading" => __("Image 2", "sympathy"),
                    "param_name" => "image_2",
                    'value' => '',
                    "description" => __("Either upload a new, or choose an existing image from your media library", "sympathy"),
                    "dependency" => array(
                        'element' => "column",
                        'value' => array(
                            'two_col',
                            'three_col',
                            'fourth_col',
                        )
                    )
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Amount Donation 2", "sympathy"),
                    "param_name" => "amount_donation_2",
                    "value" => "$0,0",
                    "description" => esc_html__("", "sympathy"),
                    "dependency" => array(
                        'element' => "column",
                        'value' => array(
                            'two_col',
                            'three_col',
                            'fourth_col',
                        )
                    ),
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Content 2", "sympathy"),
                    "param_name" => "content_2",
                    "value" => "",
                    "description" => esc_html__("", "sympathy"),
                    "dependency" => array(
                        'element' => "column",
                        'value' => array(
                            'two_col',
                            'three_col',
                            'fourth_col',
                        )
                    ),
                ),
                array(
                    "type" => "ult_img_single",
                    "heading" => __("Image 3", "sympathy"),
                    "param_name" => "image_3",
                    'value' => '',
                    "description" => __("Either upload a new, or choose an existing image from your media library", "sympathy"),
                    "description" => esc_html__("", "sympathy"),
                    "dependency" => array(
                        'element' => "column",
                        'value' => array(
                            'three_col',
                            'fourth_col',
                        )
                    )
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Amount Donation 3", "sympathy"),
                    "param_name" => "amount_donation_3",
                    "value" => "$0,0",
                    "description" => esc_html__("", "sympathy"),
                    "dependency" => array(
                        'element' => "column",
                        'value' => array(
                            'three_col',
                            'fourth_col',
                        )
                    ),
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Content 3", "sympathy"),
                    "param_name" => "content_3",
                    "value" => "",
                    "description" => esc_html__("", "sympathy"),
                    "dependency" => array(
                        'element' => "column",
                        'value' => array(
                            'three_col',
                            'fourth_col',
                        )
                    ),
                ),
                array(
                    "type" => "ult_img_single",
                    "heading" => __("Image 4", "sympathy"),
                    "param_name" => "image_4",
                    'value' => '',
                    "description" => __("Either upload a new, or choose an existing image from your media library", "sympathy"),
                    "description" => esc_html__("", "sympathy"),
                    "dependency" => array(
                        'element' => "column",
                        'value' => array(
                            'fourth_col',
                        )
                    ),
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Amount Donation 4", "sympathy"),
                    "param_name" => "amount_donation_4",
                    "value" => "$0,0",
                    "description" => esc_html__("", "sympathy"),
                    "dependency" => array(
                        'element' => "column",
                        'value' => array(
                            'fourth_col',
                        )
                    ),
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Content 4", "sympathy"),
                    "param_name" => "content_4",
                    "value" => "",
                    "description" => esc_html__("", "sympathy"),
                    "dependency" => array(
                        'element' => "column",
                        'value' => array(
                            'fourth_col',
                        )
                    ),
                ),
                array(
                    "type" => "dropdown",
                    "heading" => esc_html__("Position Absolute?", "sympathy"),
                    "param_name" => "position",
                    "value" => array(
                        esc_html__('Default', 'sympathy') => 'default',
                        esc_html__('Left', 'sympathy') => 'left',
                        esc_html__('Right', 'sympathy') => 'right',
                    ),
                    "description" => esc_html__("Move box to right/left.", "sympathy"),
                ),
                array(
                    "type" => "number",
                    "heading" => esc_html__("Position Left", "sympathy"),
                    "param_name" => "pst_left",
                    "value" => 0,
                    "description" => esc_html__("", "sympathy"),
                    "dependency" => array(
                        'element' => "position",
                        'value' => array(
                            'left'
                        )
                    ),
                ),
                array(
                    "type" => "number",
                    "heading" => esc_html__("Position Right", "sympathy"),
                    "param_name" => "pst_right",
                    "value" => 0,
                    "description" => esc_html__("", "sympathy"),
                    "dependency" => array(
                        'element' => "position",
                        'value' => array(
                            'right'
                        )
                    ),
                ),
                
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Extra class name", "sympathy"),
                    "param_name" => "el_class",
                    "value" => "",
                    "description" => esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in Custom CSS Shortcode or Masterkey Custom CSS option.", "sympathy")
                ),
            )
        ));
    }

}