<?php
/**
 * Causes List
 *
 * @package Sympathy
 * @author QTC Media
 * @link http://qtcmedia.com
 */
/* -------------------Causes List---------------------- */
sympathy_insert_shortcode('sympathy_causes_list', 'sympathy_causes_list_template');
if (!function_exists('sympathy_causes_list_template')):

    function sympathy_causes_list_template($attr) {
        global $sympathy_smof_data;
        ob_start();
        extract(shortcode_atts(array(
            'template' => '1',
            'post' => 'campaign',
            'posts_per_page' => '1000',
            'categories' => '',
            'el_class' => '',
            'column' => 'col-xs-12 col-sm-6 col-md-4',
            'orderby' => 'date',
            'order' => 'DESC',
            'cb_pagination' => '',
            'popup_link' => 'link_detail',
                        ), $attr));
        $paged = (get_query_var('paged')) ? get_query_var('paged') : 1;
        $args = array(
            'post_type' => $post,
            'post_status' => 'publish',
            'paged' => $paged,
        );
        if (isset($posts_per_page) && is_numeric($posts_per_page)):
            $args['posts_per_page'] = $posts_per_page;
        endif;
        if (isset($orderby) && $orderby != 'none'):
            $args['orderby'] = $orderby;
        endif;
        if (isset($order) && $order != 'none'):
            $args['order'] = $order;
        endif;
        if (!empty($categories)):
            $terms = explode(',', $categories);
            $args['tax_query'] = array(
                'relation' => 'OR',
                array(
                    'taxonomy' => 'campaign_category',
                    'field' => 'slug',
                    'terms' => $terms,
                    'operator' => 'IN',
            ));
        endif;
        wp_enqueue_script('jquery-sglide');
        wp_enqueue_script('jquery-magnific-popup');
        wp_enqueue_style('magnific-popup');

        $wp_query = new WP_Query($args);

        if ($template == "1") {
            $template = "template-1";
        } else {
            $template = "template-2";
        }

        if ($wp_query->have_posts()) :
            $rand_grid = rand(5, 12315646131);
            $id_class = md5(time() . ' ' . $rand_grid);
            ?>
            <div class="row sympathy_causes_list sympathy_causes_list<?php echo esc_attr($id_class); ?>  <?php echo esc_attr($template) . ' ' . esc_attr($el_class); ?>">
                <?php
                while ($wp_query->have_posts()) : $wp_query->the_post();
                    $post_id = get_the_ID();
                    $campaign = new Charitable_Campaign($post_id);
                    $raisedpercent = $campaign->get_percent_donated();
                    $percent = str_replace('%', '', $raisedpercent);
                    $currency_helper = charitable_get_currency_helper();

                    $thumb_id = get_post_thumbnail_id($post_id);
                    $alt = get_post_meta($thumb_id, '_wp_attachment_image_alt', true);
                    $url = wp_get_attachment_url($thumb_id);
                    if ($template == "template-1") {
                        if ($column == 'col-xs-12 col-sm-6 col-md-6') {
                            $image = sympathy_image_resize($url, 570, 370, true);
                        } elseif ($column == 'col-xs-12 col-sm-12 col-md-12') {
                            $image = $url;
                        } else {
                            $image = sympathy_image_resize($url, 370, 240, true);
                        }

                        $image_mobile = sympathy_image_resize($url, 720, 360, true);
                        if (!empty($image_mobile)) {
                            $image_mobile = $image_mobile;
                        } else {
                            $image_mobile = $url;
                        }
                    } else {
                        $image = sympathy_image_resize($url, 485, 530, true);
                    }
                    if ($template == "template-1") {
                        ?>
                        <div class="<?php echo esc_attr($column); ?> column_private item_sympathy_causes">
                            <div class="sympathy-box-image">
                                <a href="<?php echo esc_url(the_permalink()); ?>">
                                    <picture>
                                        <source srcset="<?php echo esc_url($image_mobile); ?>" media="(max-width: 767px)">
                                        <?php
                                        if (!empty($image)) {
                                            ?>
                                            <img src="<?php echo esc_url($image); ?>" alt="<?php if (count($alt)) echo esc_attr($alt); ?>">
                                            <?php
                                        }else {
                                            ?>
                                            <img src="<?php echo esc_url($url); ?>" alt="<?php if (count($alt)) echo esc_attr($alt); ?>">
                                            <?php
                                        }
                                        ?>
                                    </picture>
                                </a>
                                <div class="view_causes">
                                    <div class="row">
                                        <div class="col-xs-8 col-sm-6 view_left">
                                            <a href="<?php echo get_permalink(); ?>"><i class="fa fa-link" aria-hidden="true"></i> <?php echo esc_html__('Show more', 'sympathy'); ?></a>
                                        </div>
                                        <div class="col-xs-4 col-sm-6 view_right">
                                            <a href="javascript:void(0)" class="sympathy-post-like" data-id="<?php echo get_the_ID(); ?>"><i class="<?php echo!isset($_COOKIE['sympathy_post_like_' . get_the_ID()]) ? 'fa fa-heart-o' : 'fa fa-heart'; ?>" aria-hidden="true"></i></a>
                                            <a href="<?php the_post_thumbnail_url('full'); ?>"  class="sympathy-popup-image"><i class="fa fa-arrows-alt" aria-hidden="true"></i></a>
                                        </div> 
                                    </div> 
                                </div> 
                            </div>
                            <div class="info_causes sympathy-grid-column">
                                <a href="<?php echo get_permalink(); ?>"><h3><?php echo get_the_title(); ?></h3></a>
                                <div class="sympathy-date"><i class="fa fa-clock-o" aria-hidden="true"></i> <?php echo get_the_time('F j, Y'); ?></div>
                                <div class="excert_causes">
                                    <?php echo get_the_excerpt(); ?>
                                </div>
                                <div class="percent_causes">
                                    <input type="hidden" value="<?php echo esc_attr($percent); ?>" name="sympathy_percent" class="sympathy_percent_<?php echo esc_attr($id_class . $post_id); ?>">
                                    <span class="funed"><?php echo esc_attr($raisedpercent); ?> <?php echo esc_html__('Funded', 'sympathy'); ?></span>
                                    <div id="causes-slider-<?php echo esc_attr($id_class . $post_id); ?>" class="slider_bar" data-id="<?php echo esc_attr($id_class . $post_id); ?>"></div>
                                    <span class="donate_raise"><strong><?php echo esc_html__('Raised: ', 'sympathy'); ?></strong> <?php echo esc_attr($currency_helper->get_monetary_amount($campaign->get_donated_amount())); ?></span>
                                    <span class="donate_goal"><strong><?php echo esc_html__('Goal: ', 'sympathy'); ?></strong> <?php echo esc_attr($currency_helper->get_monetary_amount($campaign->get('goal'))); ?></span>
                                </div>
                                <div class="bt_causes">
                                    <?php if ($popup_link == "popup_form") { ?>
                                        <a href="#sympathy_popup_donate_<?php echo esc_attr($id_class . $post_id); ?>" class="btn btn-default bt_donate_causes" data-id="<?php echo esc_attr($post_id); ?>"><?php echo esc_html__('DONATE NOW', 'sympathy'); ?></a>
                                    <?php } else {
                                        ?>
                                        <a href="<?php echo get_permalink(); ?>" class="btn btn-default"><?php echo esc_html__('DONATE NOW', 'sympathy'); ?></a>
                                    <?php } ?>
                                </div>
                            </div> 

                        </div>
                        <?php
                    } else {
                        ?>
                        <div class="col-md-12 column_private item_sympathy_causes">
                            <div class="row char-flex-box">
                                <div class="sympathy-box-image char-flex-box col-md-5">
                                    <div class="box-img spt-hv-scale-img">
                                        <picture>
                                            <?php
                                            if (!empty($image)) {
                                                ?>
                                                <img src="<?php echo esc_url($image); ?>" alt="<?php if (count($alt)) echo esc_attr($alt); ?>">
                                                <?php
                                            }else {
                                                ?>
                                                <img src="<?php echo esc_url($url); ?>" alt="<?php if (count($alt)) echo esc_attr($alt); ?>">
                                                <?php
                                            }
                                            ?>
                                        </picture>
                                    </div>
                                </div>
                                <div class="info_causes char-flex-box sympathy-grid-column col-md-7">
                                    <div class="box-c-w char-flex-box char-flex-box-ai-center">
                                        <div class="box-content char-text-center char-flex">
                                            <a href="<?php echo get_permalink(); ?>"><h3><?php echo get_the_title(); ?></h3></a>
                                            <div class="sympathy-date"><i class="fa fa-clock-o" aria-hidden="true"></i> <?php echo get_the_time('F j, Y'); ?></div>
                                            <div class="excert_causes">
                                                <?php echo get_the_excerpt(); ?>
                                            </div>
                                            <div class="percent_causes">
                                                <input type="hidden" value="<?php echo esc_attr($percent); ?>" name="sympathy_percent" class="sympathy_percent_<?php echo esc_attr($id_class . $post_id); ?>">
                                                <span class="funed"><?php echo esc_attr($raisedpercent); ?> <?php echo esc_html__('Funded', 'sympathy'); ?></span>
                                                <div id="causes-slider-<?php echo esc_attr($id_class . $post_id); ?>" class="slider_bar" data-id="<?php echo esc_attr($id_class . $post_id); ?>"></div>
                                                <span class="donate_raise"><strong><?php echo esc_html__('Raised: ', 'sympathy'); ?></strong> <?php echo esc_attr($currency_helper->get_monetary_amount($campaign->get_donated_amount())); ?></span>
                                                <span class="donate_goal"><strong><?php echo esc_html__('Goal: ', 'sympathy'); ?></strong> <?php echo esc_attr($currency_helper->get_monetary_amount($campaign->get('goal'))); ?></span>
                                            </div>
                                            <div class="bt_causes">
                                                <?php if ($popup_link == "popup_form") { ?>
                                                    <a href="#sympathy_popup_donate_<?php echo esc_attr($id_class . $post_id); ?>" class="btn btn-default bt_donate_causes" data-id="<?php echo esc_attr($post_id); ?>"><?php echo esc_html__('DONATE NOW', 'sympathy'); ?></a>
                                                <?php } else {
                                                    ?>
                                                    <a href="<?php echo get_permalink(); ?>" class="btn btn-default"><?php echo esc_html__('DONATE NOW', 'sympathy'); ?></a>
                                                <?php } ?>
                                            </div>
                                        </div>
                                    </div>
                                </div> 
                            </div>
                        </div>
                        <?php
                    }
                    if ($popup_link == "popup_form") {
                        ?>
                        <div id="sympathy_popup_donate_<?php echo esc_attr($id_class . $post_id); ?>" class="mfp-hide white-popup-block">
                            <div class="sympathy_donate_content">
                                <?php
                                $modal_class = apply_filters('charitable_modal_window_class', 'charitable-modal');
                                ?>
                                <div id="charitable-donation-form-modal-<?php echo esc_attr($id_class . $post_id); ?>" class="charitable-donation-form-modal <?php echo esc_attr($modal_class) ?>">
                                    <?php $campaign->get_donation_form()->render() ?>
                                </div>
                            </div>
                        </div>
                        <?php
                    }
                endwhile;
                ?>  
                <?php if (isset($attr['cb_pagination']) && $attr['cb_pagination']): ?>
                    <div class="sympathy_paination_link">
                        <?php sympathy_pagination_causes($wp_query); ?>
                    </div>
                    <?php
                endif;
                ?>
            </div>
            <?php
        endif;
        wp_reset_postdata();

        return ob_get_clean();
    }

endif;

add_action('vc_before_init', 'sympathy_vc_causes_list');
if (!function_exists('sympathy_vc_causes_list')) {

    function sympathy_vc_causes_list() {
        vc_map(array(
            "name" => esc_html__("Causes", 'sympathy'),
            "base" => "sympathy_causes_list",
            "class" => "sympathy_causes_list",
            "category" => esc_html__('QTCThemes', 'sympathy'),
            'icon' => get_template_directory_uri() . "/images/icon/grid.png",
            'description' => esc_html__('Show list causes', 'sympathy'),
            "params" => array(
                array(
                    'type' => 'dropdown',
                    'heading' => esc_html__('Template', 'sympathy'),
                    "value" => array(
                        esc_html__("Template 1", 'sympathy') => "1",
                        esc_html__("Template 2", 'sympathy') => "2",
                    ),
                    "std" => "1",
                    'param_name' => 'template',
                    'description' => esc_html__('Select template in list causes.', 'sympathy'),
                ),
                array(
                    "type" => "textfield",
                    "class" => "",
                    "heading" => esc_html__("Post Count", 'sympathy'),
                    "param_name" => "posts_per_page",
                    "value" => "",
                    "description" => esc_html__("-1: show all,limit 1000", 'sympathy')
                ),
                array(
                    'type' => 'exploded_textarea',
                    'heading' => esc_html__('Categories', 'sympathy'),
                    'param_name' => 'categories',
                    'description' => esc_html__('Enter categories by names to narrow output (Note: only listed categories will be displayed, divide categories with linebreak (Enter)).', 'sympathy'),
                ),
                array(
                    "type" => "dropdown",
                    "class" => "",
                    "heading" => esc_html__("Columns", 'sympathy'),
                    "param_name" => "column",
                    "std" => "col-xs-12 col-sm-6 col-md-4",
                    "value" => array(
                        "1 Column" => "col-xs-12 col-sm-12 col-md-12",
                        "2 Columns" => "col-xs-12 col-sm-6 col-md-6",
                        "3 Columns" => "col-xs-12 col-sm-6 col-md-4",
                        "4 Columns" => "col-xs-12 col-sm-4 col-md-3",
                    ),
                    "dependency" => array(
                        'element' => "template",
                        'value' => "1"
                    )
                ),
                array(
                    "type" => "dropdown",
                    "heading" => esc_html__('Order by', 'sympathy'),
                    "param_name" => "orderby",
                    "value" => array(
                        "None" => "none",
                        "Title" => "title",
                        "Date" => "date",
                        "ID" => "ID"
                    ),
                    "std" => "none",
                    "description" => esc_html__('Order by ("none", "title", "date", "ID").', 'sympathy')
                ),
                array(
                    "type" => "dropdown",
                    "heading" => esc_html__('Order', 'sympathy'),
                    "param_name" => "order",
                    "value" => Array(
                        "None" => "none",
                        "ASC" => "ASC",
                        "DESC" => "DESC"
                    ),
                    "std" => "none",
                    "description" => esc_html__('Order ("None", "Asc", "Desc").', 'sympathy')
                ),
                array(
                    "type" => "dropdown",
                    "heading" => esc_html__('Popup form or link detail', 'sympathy'),
                    "param_name" => "popup_link",
                    "value" => Array(
                        "Popup form" => "popup_form",
                        "Link detail" => "link_detail",
                    ),
                    "std" => "link_detail",
                //"description" => esc_html__('', 'sympathy')
                ),
                array(
                    "type" => "checkbox",
                    "heading" => __('Click Show Pagination', 'sympathy'),
                    "param_name" => "cb_pagination",
                    "value" => "",
                    "description" => __('Click a marker to show function pagination (Default Show).', 'sympathy')
                ),
                array(
                    "type" => "textfield",
                    "class" => "",
                    "heading" => esc_html__("Extra Class", 'sympathy'),
                    "param_name" => "el_class",
                    "value" => "",
                ),
            )
        ));
    }

}
if (!function_exists('sympathy_donate_form_display')) {
    add_action('wp_ajax_sympathy_donate_form', 'sympathy_donate_form_display');
    add_action('wp_ajax_nopriv_sympathy_donate_form', 'sympathy_donate_form_display');

    function sympathy_donate_form_display() {
        $campaign = $_POST['campaign'];
        if ($campaign) {
            $campaign = new Charitable_Campaign($campaign);
            $modal_class = apply_filters('charitable_modal_window_class', 'charitable-modal');
            ?>
            <div id="charitable-donation-form-modal" class="<?php echo esc_attr($modal_class) ?>">
                <?php $campaign->get_donation_form()->render() ?>
            </div>
            <?php
        }
        die();
    }

}
if (!function_exists('sympathy_popup_content_donate')) {

    function sympathy_popup_content_donate() {
        global $post;
        if (is_a($post, 'WP_Post') && has_shortcode($post->post_content, 'sympathy_causes_list')) {
            wp_enqueue_script('accounting');
            wp_enqueue_script('charitable-script');
        }
        ob_start();
        ?>
        <div id="sympathy_popup_donate" class="mfp-hide white-popup-block">
            <div class="sympathy_loadding">
                <img src="<?php echo SYMPATHY_THEME_URI . '/assets/images/loading.gif'; ?>" alt="loading" class="sympathy_img_loading" style="display:none;"/>
            </div>
            <div class="sympathy_donate_contet">
            </div>
        </div>
        <?php
        echo ob_get_clean();
    }

    add_action('wp_footer', 'sympathy_popup_content_donate');
}