<?php
/**
 * Causes Slider
 *
 * @package Sympathy
 * @author QTC Media
 * @link http://qtcmedia.com
 */
/* -------------------Causes Slider---------------------- */
sympathy_insert_shortcode('sympathy_causes_slider', 'sympathy_causes_slider_template');
if (!function_exists('sympathy_causes_slider_template')):

    function sympathy_causes_slider_template($attr) {
        global $sympathy_smof_data;
        ob_start();
        extract(shortcode_atts(array(
            'post' => 'campaign',
            'posts_per_page' => '1000',
            'categories' => '',
            'el_class' => '',
            'orderby' => 'date',
            'order' => 'DESC',
            'popup_link' => 'link_detail',
                        ), $attr));
        $args = array(
            'post_type' => $post,
            'post_status' => 'publish',
        );
        if (isset($posts_per_page) && is_numeric($posts_per_page)):
            $args['posts_per_page'] = $posts_per_page;
        endif;
        if (isset($orderby) && $orderby != 'none'):
            $args['orderby'] = $orderby;
        endif;
        if (isset($order) && $order != 'none'):
            $args['order'] = $order;
        endif;
        if (!empty($categories)):
            $terms = explode(',', $categories);
            $args['tax_query'] = array(
                'relation' => 'OR',
                array(
                    'taxonomy' => 'campaign_category',
                    'field' => 'slug',
                    'terms' => $terms,
                    'operator' => 'IN',
            ));
        endif;
        wp_enqueue_script('jquery-sglide');
        wp_enqueue_script('jquery-magnific-popup');
        wp_enqueue_style('magnific-popup');

        wp_enqueue_script('slick.js');
        wp_enqueue_style('slick');
        $wp_query = new WP_Query($args);
        if ($wp_query->have_posts()) :
            $rand_grid = rand(5, 12315646131);
            $id_class = md5(time() . ' ' . $rand_grid);
            ?>
            <div id="sympathy_causes_slider<?php echo esc_attr($id_class); ?>" class="sympathy_causes_slider sympathy_causes_slider<?php echo esc_attr($id_class); ?>  <?php echo esc_attr($el_class); ?>">
                <div class="sympathy-container">
                    <div class="cause-content">
                        <ul class="slick-slider slick-cause">
                            <?php
                            while ($wp_query->have_posts()) : $wp_query->the_post();
                                $post_id = get_the_ID();
                                $campaign = new Charitable_Campaign($post_id);
                                $raisedpercent = $campaign->get_percent_donated();
                                $percent = str_replace('%', '', $raisedpercent);
                                $currency_helper = charitable_get_currency_helper();

                                $thumb_id = get_post_thumbnail_id($post_id);
                                $alt = get_post_meta($thumb_id, '_wp_attachment_image_alt', true);
                                $url = wp_get_attachment_url($thumb_id);
                                $image = sympathy_image_resize($url, 570, 390, true);
                                ?>

                                <li class="causes-slider-item">
                                    <div class="box-wrap">
                                        <div class="box">
                                            <div class="row char-flex-box">
                                                <div class="col-img char-flex-box col-xs-12 col-sm-12 col-md-6 col-lg-6 col-md-push-6 col-lg-push-6">
                                                    <div class="box-img spt-hv-scale-img">
                                                        <?php
                                                        if (!empty($image)) {
                                                            ?>
                                                            <img src="<?php echo esc_url($image); ?>" alt="<?php if (count($alt)) echo esc_attr($alt); ?>">
                                                            <?php
                                                        }else {
                                                            ?>
                                                            <img src="<?php echo esc_url($url); ?>" alt="<?php if (count($alt)) echo esc_attr($alt); ?>">
                                                            <?php
                                                        }
                                                        ?>
                                                    </div>
                                                </div>
                                                <div class="col-cont char-flex-box col-xs-12 col-sm-12 col-md-6 col-lg-6 col-md-pull-6 col-lg-pull-6">
                                                    <div class="char-flex-box char-flex-box-ai-center">
                                                        <div class="box-content char-text-center char-flex">
                                                            <a href="<?php echo get_permalink(); ?>"><h3 class="title"><?php echo get_the_title(); ?></h3></a>
                                                            <div class="excert_causes">
                                                                <p>
                                                                    <?php echo get_the_excerpt(); ?>
                                                                </p>
                                                            </div>
                                                            <div class="percent_causes char-text-center">
                                                                <input type="hidden" value="<?php echo esc_attr($percent); ?>" name="sympathy_percent" class="sympathy_percent_<?php echo esc_attr($id_class . $post_id); ?>">
                                                                <span  id="causes-slider-funed-<?php echo esc_attr($id_class . $post_id); ?>" class="funed" style="left:<?php echo esc_attr($raisedpercent); ?>;"><?php echo esc_attr($raisedpercent); ?></span>
                                                                <div id="causes-slider-<?php echo esc_attr($id_class . $post_id); ?>" class="slider_bar" data-id="<?php echo esc_attr($id_class . $post_id); ?>"></div>
                                                                <span class="donate_raise"><strong><?php echo esc_html__('Raised: ', 'sympathy'); ?></strong> <?php echo esc_attr($currency_helper->get_monetary_amount($campaign->get_donated_amount())); ?></span>
                                                                <span class="donate_goal"><strong><?php echo esc_html__('Goal: ', 'sympathy'); ?></strong> <?php echo esc_attr($currency_helper->get_monetary_amount($campaign->get('goal'))); ?></span>
                                                            </div>
                                                            <div class="bt_causes char-text-center">
                                                                <?php if ($popup_link == "popup_form") { ?>
                                                                    <a href="#sympathy_popup_donate_<?php echo esc_attr($id_class . $post_id); ?>" class="btn btn-default bt_donate_causes" data-id="<?php echo esc_attr($post_id); ?>"><?php echo esc_html__('DONATE NOW', 'sympathy'); ?></a>
                                                                <?php } else {
                                                                    ?>
                                                                    <a href="<?php echo get_permalink(); ?>" class="btn btn-default"><?php echo esc_html__('DONATE NOW', 'sympathy'); ?></a>
                                                                <?php } ?>
                                                            </div>
                                                            <?php if ($popup_link == "popup_form") { ?>
                                                                <div id="sympathy_popup_donate_<?php echo esc_attr($id_class . $post_id); ?>" class="mfp-hide white-popup-block">
                                                                    <div class="sympathy_donate_content">
                                                                        <?php
                                                                        $modal_class = apply_filters('charitable_modal_window_class', 'charitable-modal');
                                                                        ?>
                                                                        <div id="charitable-donation-form-modal-<?php echo esc_attr($id_class . $post_id); ?>" class="charitable-donation-form-modal <?php echo esc_attr($modal_class) ?>">
                                                                            <?php $campaign->get_donation_form()->render() ?>
                                                                        </div>
                                                                    </div>
                                                                </div>
                                                            <?php } ?>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </li>
                                <?php
                            endwhile;
                            ?> 
                        </ul>
                        <ul class="slick-slider slick-year slick-year-v1">
                            <?php
                            while ($wp_query->have_posts()) : $wp_query->the_post();
                                $post_id = get_the_ID();
                                $date = get_the_date('Y-m-d');
                                ?>
                                <li>
                                    <div class="year">
                                        <h5><?php echo esc_attr($date); ?></h5>
                                    </div>
                                </li>
                                <?php
                            endwhile;
                            ?> 
                        </ul>
                    </div>
                </div>
            </div>
            <?php
        endif;
        wp_reset_postdata();

        return ob_get_clean();
    }

endif;

add_action('vc_before_init', 'sympathy_vc_causes_slider');
if (!function_exists('sympathy_vc_causes_slider')) {

    function sympathy_vc_causes_slider() {
        vc_map(array(
            "name" => esc_html__("Causes Slider", 'sympathy'),
            "base" => "sympathy_causes_slider",
            "class" => "sympathy_causes_slider",
            "category" => esc_html__('QTCThemes', 'sympathy'),
            'icon' => get_template_directory_uri() . "/images/icon/grid.png",
            'description' => esc_html__('Show slider causes', 'sympathy'),
            "params" => array(
                array(
                    "type" => "textfield",
                    "class" => "",
                    "heading" => esc_html__("Post Count", 'sympathy'),
                    "param_name" => "posts_per_page",
                    "value" => "",
                    "description" => esc_html__("-1: show all,limit 1000", 'sympathy')
                ),
                array(
                    'type' => 'exploded_textarea',
                    'heading' => esc_html__('Categories', 'sympathy'),
                    'param_name' => 'categories',
                    'description' => esc_html__('Enter categories by names to narrow output (Note: only listed categories will be displayed, divide categories with linebreak (Enter)).', 'sympathy'),
                ),
                array(
                    "type" => "dropdown",
                    "heading" => esc_html__('Order by', 'sympathy'),
                    "param_name" => "orderby",
                    "value" => array(
                        "None" => "none",
                        "Title" => "title",
                        "Date" => "date",
                        "ID" => "ID"
                    ),
                    "std" => "none",
                    "description" => esc_html__('Order by ("none", "title", "date", "ID").', 'sympathy')
                ),
                array(
                    "type" => "dropdown",
                    "heading" => esc_html__('Order', 'sympathy'),
                    "param_name" => "order",
                    "value" => Array(
                        "None" => "none",
                        "ASC" => "ASC",
                        "DESC" => "DESC"
                    ),
                    "std" => "none",
                    "description" => esc_html__('Order ("None", "Asc", "Desc").', 'sympathy')
                ),
                array(
                    "type" => "dropdown",
                    "heading" => esc_html__('Popup form or link detail', 'sympathy'),
                    "param_name" => "popup_link",
                    "value" => Array(
                        "Popup form" => "popup_form",
                        "Link detail" => "link_detail",
                    ),
                    "std" => "link_detail",
                //"description" => esc_html__('', 'sympathy')
                ),
                array(
                    "type" => "textfield",
                    "class" => "",
                    "heading" => esc_html__("Extra Class", 'sympathy'),
                    "param_name" => "el_class",
                    "value" => "",
                ),
            )
        ));
    }

}