<?php
/**
 * Causes Slider 2
 *
 * @package Sympathy
 * @author QTC Media
 * @link http://qtcmedia.com
 */
/* -------------------Causes Slider 2---------------------- */
sympathy_insert_shortcode('sympathy_causes_slider_2', 'sympathy_causes_slider_2_template');
if (!function_exists('sympathy_causes_slider_2_template')):

    function sympathy_causes_slider_2_template($attr) {
        global $sympathy_smof_data;
        ob_start();
        extract(shortcode_atts(array(
            'post' => 'campaign',
            'posts_per_page' => '1000',
            'categories' => '',
            'el_class' => '',
            'orderby' => 'date',
            'order' => 'DESC',
            'popup_link' => 'link_detail',
            'btn' => '',
            'title_btn' => 'Become Volunteer',
            'link_btn' => '#',
                        ), $attr));
        $args = array(
            'post_type' => $post,
            'post_status' => 'publish',
        );
        if (isset($posts_per_page) && is_numeric($posts_per_page)):
            $args['posts_per_page'] = $posts_per_page;
        endif;
        if (isset($orderby) && $orderby != 'none'):
            $args['orderby'] = $orderby;
        endif;
        if (isset($order) && $order != 'none'):
            $args['order'] = $order;
        endif;
        if (!empty($categories)):
            $terms = explode(',', $categories);
            $args['tax_query'] = array(
                'relation' => 'OR',
                array(
                    'taxonomy' => 'campaign_category',
                    'field' => 'slug',
                    'terms' => $terms,
                    'operator' => 'IN',
            ));
        endif;
        wp_enqueue_script('jquery-sglide');
        wp_enqueue_script('jquery-magnific-popup');
        wp_enqueue_style('magnific-popup');

        wp_enqueue_script('slick.js');
        wp_enqueue_style('slick');
        $wp_query = new WP_Query($args);
        if ($wp_query->have_posts()) :
            $rand_grid = rand(5, 12315646131);
            $id_class = md5(time() . ' ' . $rand_grid);
            ?>
            <div id="sympathy_causes_slider_2<?php echo esc_attr($id_class); ?>" class="sympathy_causes_slider_2 sympathy_causes_slider_2<?php echo esc_attr($id_class); ?>  <?php echo esc_attr($el_class); ?>">
                <div class="sympathy-container">
                    <div class="cause-content">
                        <ul class="owl-carousel owl-theme sympathy-causes-cause">
                            <?php
                            while ($wp_query->have_posts()) : $wp_query->the_post();
                                $post_id = get_the_ID();
                                $campaign = new Charitable_Campaign($post_id);
                                $raisedpercent = $campaign->get_percent_donated();
                                $percent = str_replace('%', '', $raisedpercent);
                                $currency_helper = charitable_get_currency_helper();

                                $thumb_id = get_post_thumbnail_id($post_id);
                                $alt = get_post_meta($thumb_id, '_wp_attachment_image_alt', true);
                                $url = wp_get_attachment_url($thumb_id);
                                $image = sympathy_image_resize($url, 570, 390, true);
                                ?>
                                <li>
                                    <div class="box text-center">
                                        <div class="box-img spt-hv-scale-img">
                                            <?php
                                            if (!empty($image)) {
                                                ?>
                                                <img src="<?php echo esc_url($image); ?>" alt="<?php if (count($alt)) echo esc_attr($alt); ?>">
                                                <?php
                                            }else {
                                                ?>
                                                <img src="<?php echo esc_url($url); ?>" alt="<?php if (count($alt)) echo esc_attr($alt); ?>">
                                                <?php
                                            }
                                            ?>
                                        </div>
                                        <div class="box-donate">
                                            <span class="donate_goal"><?php echo esc_attr($currency_helper->get_monetary_amount($campaign->get('goal'))); ?></span>
                                            <a href="<?php echo get_permalink(); ?>" class="link-title"><h3 class="title"><?php echo get_the_title(); ?></h3></a>
                                            <div class="bt_causes char-text-center">
                                                <?php if ($popup_link == "popup_form") { ?>
                                                    <a href="#sympathy_popup_donate_<?php echo esc_attr($id_class . $post_id); ?>" class="btn btn-default bt_donate_causes" data-id="<?php echo esc_attr($post_id); ?>"><?php echo esc_html__('DONATE NOW', 'sympathy'); ?></a>
                                                <?php } else {
                                                    ?>
                                                    <a href="<?php echo get_permalink(); ?>" class="btn btn-default"><?php echo esc_html__('DONATE NOW', 'sympathy'); ?></a>
                                                <?php } ?>
                                            </div>
                                            <?php if ($popup_link == "popup_form") { ?>
                                                <div id="sympathy_popup_donate_<?php echo esc_attr($id_class . $post_id); ?>" class="mfp-hide white-popup-block">
                                                    <div class="sympathy_donate_content">
                                                        <?php
                                                        $modal_class = apply_filters('charitable_modal_window_class', 'charitable-modal');
                                                        ?>
                                                        <div id="charitable-donation-form-modal-<?php echo esc_attr($id_class . $post_id); ?>" class="charitable-donation-form-modal <?php echo esc_attr($modal_class) ?>">
                                                            <?php $campaign->get_donation_form()->render() ?>
                                                        </div>
                                                    </div>
                                                </div>
                                            <?php } ?>
                                        </div>
                                    </div>
                                </li>

                                <?php
                            endwhile;
                            ?> 
                        </ul>
                    </div>
                    <?php
                    if ($btn == "enable") {
                        ?>
                        <div class="spt-button text-center">
                            <a href="<?php echo esc_attr($link_btn); ?>" class="btn btn-default"><?php echo esc_attr($title_btn); ?></a>
                        </div>
                    <?php } ?>
                </div>
            </div>
            <?php
        endif;
        wp_reset_postdata();

        return ob_get_clean();
    }

endif;

add_action('vc_before_init', 'sympathy_vc_causes_slider_2');
if (!function_exists('sympathy_vc_causes_slider_2')) {

    function sympathy_vc_causes_slider_2() {
        vc_map(array(
            "name" => esc_html__("Causes Slider 2", 'sympathy'),
            "base" => "sympathy_causes_slider_2",
            "class" => "sympathy_causes_slider_2",
            "category" => esc_html__('QTCThemes', 'sympathy'),
            'icon' => get_template_directory_uri() . "/images/icon/grid.png",
            'description' => esc_html__('Show slider causes 2', 'sympathy'),
            "params" => array(
                array(
                    "type" => "textfield",
                    "class" => "",
                    "heading" => esc_html__("Post Count", 'sympathy'),
                    "param_name" => "posts_per_page",
                    "value" => "",
                    "description" => esc_html__("-1: show all,limit 1000", 'sympathy')
                ),
                array(
                    'type' => 'exploded_textarea',
                    'heading' => esc_html__('Categories', 'sympathy'),
                    'param_name' => 'categories',
                    'description' => esc_html__('Enter categories by names to narrow output (Note: only listed categories will be displayed, divide categories with linebreak (Enter)).', 'sympathy'),
                ),
                array(
                    "type" => "dropdown",
                    "heading" => esc_html__('Order by', 'sympathy'),
                    "param_name" => "orderby",
                    "value" => array(
                        "None" => "none",
                        "Title" => "title",
                        "Date" => "date",
                        "ID" => "ID"
                    ),
                    "std" => "none",
                    "description" => esc_html__('Order by ("none", "title", "date", "ID").', 'sympathy')
                ),
                array(
                    "type" => "dropdown",
                    "heading" => esc_html__('Order', 'sympathy'),
                    "param_name" => "order",
                    "value" => Array(
                        "None" => "none",
                        "ASC" => "ASC",
                        "DESC" => "DESC"
                    ),
                    "std" => "none",
                    "description" => esc_html__('Order ("None", "Asc", "Desc").', 'sympathy')
                ),
                array(
                    "type" => "dropdown",
                    "heading" => esc_html__('Popup form or link detail', 'sympathy'),
                    "param_name" => "popup_link",
                    "value" => Array(
                        "Popup form" => "popup_form",
                        "Link detail" => "link_detail",
                    ),
                    "std" => "link_detail",
                //"description" => esc_html__('', 'sympathy')
                ),
                array(
                    "type" => "checkbox",
                    "heading" => esc_html__("Show button", 'sympathy'),
                    "param_name" => "btn",
                    "value" => array(
                        'Enable' => 'enable',
                    ), //value
                    "std" => " ",
                    "description" => esc_html__("Show button bottom your element.", "sympathy"),
                ),
                array(
                    "type" => "textfield",
                    "class" => "",
                    "heading" => esc_html__("Title Button", 'sympathy'),
                    "param_name" => "title_btn",
                    "value" => "Become Volunteer",
                    "std" => "Become Volunteer",
                    "description" => esc_html__("Please, enter change title button bottom.", 'sympathy'),
                ),
                array(
                    "type" => "textfield",
                    "class" => "",
                    "heading" => esc_html__("Link Button", 'sympathy'),
                    "param_name" => "link_btn",
                    "value" => "#",
                    "std" => "#",
                    "description" => esc_html__("Please, enter change link button bottom.", 'sympathy'),
                ),
                array(
                    "type" => "textfield",
                    "class" => "",
                    "heading" => esc_html__("Extra Class", 'sympathy'),
                    "param_name" => "el_class",
                    "value" => "",
                ),
            )
        ));
    }

}