<?php
/**
 * Gallery
 *
 * @package Sympathy
 * @author QTC Media
 * @link http://qtcmedia.com
 */
/* -------------------Gallery---------------------- */
sympathy_insert_shortcode('sympathy_gallery', 'sympathy_gallery_template');
if (!function_exists('sympathy_gallery_template')):

    function sympathy_gallery_template($atts, $content) {
        global $sympathy_smof_data;
        ob_start();
        extract(shortcode_atts(array(
            'column' => 3,
            'post_type' => 'post',
            'posts_per_page' => '100',
            'categories' => '',
            'order' => 'ASC',
            'orderby' => 'date',
            'pagination' => 'false',
            'el_class' => '',
                        ), $atts));
        $rand_grid = rand(5, 12315646131);
        $id = md5(time() . ' ' . $rand_grid);

        $column_css = '';

        switch ($column) {
            case 1:
                $column_css = 'one-column';
                break;
            case 2:
                $column_css = 'two-column';
                break;
            case 3:
                $column_css = 'three-column';
                break;
            case 4:
                $column_css = 'four-column';
                break;
            case 5:
                $column_css = 'five-column';
                break;
        }

        $paged = (get_query_var('paged')) ? get_query_var('paged') : 1;
        $args = array(
            'post_type' => $post_type,
            'post_status' => 'publish',
            'paged' => $paged,
        );

        if (isset($posts_per_page) && is_numeric($posts_per_page)):
            $args['posts_per_page'] = $posts_per_page;
        endif;
        if (isset($orderby) && $orderby != 'none'):
            $args['orderby'] = $orderby;
        endif;
        if (isset($order) && $order != 'none'):
            $args['order'] = $order;
        endif;
        if (!empty($categories)):
            $terms = explode(',', $categories);
            $args['tax_query'] = array(
                'relation' => 'OR',
                array(
                    'taxonomy' => 'campaign_category',
                    'field' => 'slug',
                    'terms' => $terms,
                    'operator' => 'IN',
            ));
        endif;
        wp_enqueue_script('jquery-fancybox');
        wp_enqueue_style('fancybox');
        $wp_query = new WP_Query($args);

        if ($wp_query->have_posts()) :
            $rand_grid = rand(5, 12315646131);
            $id_class = md5(time() . ' ' . $rand_grid);
            ?>
            <div id="gallery-loop-<?php echo esc_attr($id); ?>" data-query="" class="crt-gallery <?php echo esc_attr($post_type . $el_class); ?> js-loop js-el clear">
                <?php
                while ($wp_query->have_posts()) : $wp_query->the_post();
                    $post_id = get_the_ID();
                    $campaign = new Charitable_Campaign($post_id);
                    $raisedpercent = $campaign->get_percent_donated();
                    $percent = str_replace('%', '', $raisedpercent);
                    $currency_helper = charitable_get_currency_helper();

                    $thumb_id = get_post_thumbnail_id($post_id);
                    $alt = get_post_meta($thumb_id, '_wp_attachment_image_alt', true);
                    $url = wp_get_attachment_url($thumb_id);

                    if ($column_css == 2) {
                        $image = sympathy_image_resize($url, 585, 380, true);
                    } elseif ($column_css == 2) {
                        $image = $url;
                    } else {
                        $image = sympathy_image_resize($url, 384, 250, true);
                    }
                    ?>
                    <div class="<?php echo esc_attr($column_css); ?> crt-gallery-item hover-fadebox simple-frame">
                        <div class="item-holder">                                
                            <span class="gallery-inner">
                                <a href="<?php echo esc_url(the_permalink()); ?>">
                                    <?php
                                    if (!empty($image)) {
                                        ?>
                                        <img src="<?php echo esc_url($image); ?>" alt="<?php if (count($alt)) echo esc_attr($alt); ?>">
                                        <?php
                                    }else {
                                        ?>
                                        <img src="<?php echo esc_url($url); ?>" alt="<?php if (count($alt)) echo esc_attr($alt); ?>">
                                        <?php
                                    }
                                    ?>
                                </a>
                            </span>
                            <div class="view_detail_gallery">
                                <div class="row">
                                    <div class="col-xs-6 col-sm-6 view_left">
                                        <a href="<?php echo get_permalink(); ?>"><i class="fa fa-link" aria-hidden="true"></i><?php echo esc_html__('Show more', 'sympathy'); ?></a>
                                    </div>
                                    <div class="col-xs-6 col-sm-6 view_right">
                                        <a href="javascript:void(0)" class="sympathy-post-like" data-id="<?php echo get_the_ID(); ?>"><i class="<?php echo!isset($_COOKIE['sympathy_post_like_' . get_the_ID()]) ? 'fa fa-heart-o' : 'fa fa-heart'; ?>" aria-hidden="true"></i></a>
                                        <a href="<?php the_post_thumbnail_url('full'); ?>"  class="sympathy-popup-image"><i class="fa fa-arrows-alt" aria-hidden="true"></i></a>
                                    </div> 
                                </div> 
                            </div>
                        </div>                        
                    </div>                        
                    <?php
                endwhile;
                ?>  
                <?php if (isset($attr['cb_pagination']) && $attr['cb_pagination']): ?>
                    <div class="sympathy_paination_link">
                        <?php sympathy_pagination(); ?>
                    </div>
                <?php endif; ?>
                <div class="clearboth"></div>
            </div>
            <script type="text/javascript">
                jQuery(function () {
                    jQuery('a.sympathy-popup-image').fancybox({
                        'transitionIn': 'elastic',
                        'transitionOut': 'elastic',
                        'speedIn': 600,
                        'speedOut': 200,
                        'overlayShow': false
                    });
                });
            </script>
            <?php
        endif;
        wp_reset_postdata();
        return ob_get_clean();
    }

endif;

add_action('vc_before_init', 'sympathy_vc_gallery');
if (!function_exists('sympathy_vc_gallery')) {

    function sympathy_vc_gallery() {
        $postTypes = get_post_types(array());
        $postTypesList = array();
        $excludedPostTypes = array(
            'revision',
            'nav_menu_item',
            'vc_grid_item',
            'custom_css',
            'customize_changeset',
            'product_variation',
            'shop_order',
            'shop_order_refund',
            'shop_coupon',
            'shop_webhook',
            'nf_sub',
            'attachment',
        );

        if (is_array($postTypes) && !empty($postTypes)) {
            foreach ($postTypes as $postType) {
                if (!in_array($postType, $excludedPostTypes)) {
                    $label = ucfirst($postType);
                    $postTypesList[] = array(
                        $postType,
                        $label,
                    );
                }
            }
        }
        $postTypesList[] = array(
            'custom',
            __('Custom query', 'sympathy'),
        );
        $postTypesList[] = array(
            'ids',
            __('List of IDs', 'sympathy'),
        );
        vc_map(array(
            "name" => esc_html__("Gallery Image", 'sympathy'),
            "base" => "sympathy_gallery",
            "class" => "sympathy_gallery",
            "category" => esc_html__('QTCThemes', 'sympathy'),
            'icon' => get_template_directory_uri() . "/images/icon/img.png",
            'description' => esc_html__('Adds images in grids in many styles.', 'sympathy'),
            "params" => array(
                array(
                    "type" => "dropdown",
                    "heading" => esc_html__("Data source", "sympathy"),
                    'param_name' => 'post_type',
                    'value' => $postTypesList,
                    'save_always' => true,
                    'description' => __('Select content type for your grid.', 'sympathy'),
                    'admin_label' => true,
                ),
                array(
                    "type" => "number",
                    "heading" => esc_html__("How many Column?", "sympathy"),
                    "param_name" => "column",
                    "value" => 3,
                    'max' => 5,
                    'min' => 1,
                    "description" => esc_html__("How many columns would you like to appear in one row?", "sympathy"),
                ),
                array(
                    "type" => "number",
                    "heading" => esc_html__("Post Count", 'sympathy'),
                    "param_name" => "posts_per_page",
                    "value" => -1,
                    "description" => esc_html__("-1: show all, limit 100", 'sympathy')
                ),
                array(
                    'type' => 'exploded_textarea',
                    'heading' => __('Categories', 'sympathy'),
                    'param_name' => 'categories',
                    'description' => __('Enter categories by names to narrow output (Note: only listed categories will be displayed, divide categories with linebreak (Enter)).', 'sympathy'),
                    "dependency" => array(
                        'element' => "post_type",
                        'value' => array(
                            'campaign'
                        )
                    )
                ),
                array(
                    "heading" => esc_html__("Pagination?", 'sympathy'),
                    "description" => esc_html__("Enable / Disable pagination for this image loop.", 'sympathy'),
                    "param_name" => "pagination",
                    "value" => array(
                        esc_html__("No", 'sympathy') => 'false',
                        esc_html__("Yes", 'sympathy') => 'true',
                        esc_html__("None", 'sympathy') => 'none',
                    ),
                    "type" => "dropdown"
                ),
                array(
                    "heading" => esc_html__("Order", 'sympathy'),
                    "description" => esc_html__("Designates the ascending or descending order of the 'orderby' parameter.", 'sympathy'),
                    "param_name" => "order",
                    "value" => array(
                        esc_html__("ASC (ascending order)", 'sympathy') => "ASC",
                        esc_html__("DESC (descending order)", 'sympathy') => "DESC"
                    ),
                    "type" => "dropdown"
                ),
                array(
                    "heading" => esc_html__("Orderby", 'sympathy'),
                    "description" => esc_html__("Sorts retrieved gallery items by parameter.", 'sympathy'),
                    "param_name" => "orderby",
                    "value" => array(
                        esc_html__("Date", 'sympathy') => "date",
                        esc_html__("post id", 'sympathy') => "id",
                        esc_html__("title", 'sympathy') => "title",
                        esc_html__("No order", 'sympathy') => "none"
                    ),
                    "type" => "dropdown"
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Extra class name", "sympathy"),
                    "param_name" => "el_class",
                    "value" => "",
                    "description" => esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in Custom CSS Shortcode or Masterkey Custom CSS option.", "sympathy")
                ),
            )
        ));
    }

}