<?php
/**
 * Gallery Slider
 *
 * @package Sympathy
 * @author QTC Media
 * @link http://qtcmedia.com
 */
/* -------------------Gallery Slider---------------------- */
sympathy_insert_shortcode('sympathy_gallery_slider', 'sympathy_gallery_slider_template');
if (!function_exists('sympathy_gallery_slider_template')):

    function sympathy_gallery_slider_template($atts, $content) {
        global $sympathy_smof_data;
        $disable_filter = '';
        ob_start();
        extract(shortcode_atts(array(
            'post_type' => 'post',
            'posts_per_page' => '100',
            'categories' => '',
            'order' => 'ASC',
            'orderby' => 'date',
            'el_class' => '',
            'disable_filter' => '',
                        ), $atts));
        $rand_grid = rand(5, 12315646131);
        $id = md5(time() . ' ' . $rand_grid);

        $paged = (get_query_var('paged')) ? get_query_var('paged') : 1;
        $args = array(
            'post_type' => $post_type,
            'post_status' => 'publish',
            'paged' => $paged,
        );

        if (isset($posts_per_page) && is_numeric($posts_per_page)):
            $args['posts_per_page'] = $posts_per_page;
        endif;
        if (isset($orderby) && $orderby != 'none'):
            $args['orderby'] = $orderby;
        endif;
        if (isset($order) && $order != 'none'):
            $args['order'] = $order;
        endif;
        if (!empty($categories)):
            $terms = explode(',', $categories);
            $args['tax_query'] = array(
                'relation' => 'OR',
                array(
                    'taxonomy' => 'campaign_category',
                    'field' => 'slug',
                    'terms' => $terms,
                    'operator' => 'IN',
            ));
        endif;
        wp_enqueue_script('jquery-fancybox');
        wp_enqueue_style('fancybox');

        wp_enqueue_script('slick.js');
        wp_enqueue_style('slick');

        $wp_query = new WP_Query($args);

        if ($wp_query->have_posts()) :
            $rand_grid = rand(5, 12315646131);
            $id = md5(time() . ' ' . $rand_grid);
            ?>
            <div id="gallery-slider-<?php echo esc_attr($id); ?>" class="crt-gallery-slider <?php echo esc_attr($post_type . $el_class); ?> js-loop js-el clear">
                <div class="our-gallery-slick">
                    <?php if (empty($disable_filter)): ?>
                        <div class="our-gallery-slick-menu spt-filter-wrap clearfix">
                            <div class="spt-grid-filter-inphone hidden">
                                <a href="javascript:;"><span><?php echo esc_html__('Select Filter', 'sympathy'); ?></span></a>
                            </div>
                            <ul class="spt-filter-category cate-filter">
                                <li id="all_<?php echo esc_attr($id); ?>" class="active button-filter"><a href="javascript:;"><?php echo esc_html__('View All', 'sympathy'); ?></a></li>
                                <?php
                                $taxonomy_name = get_object_taxonomies($post_type, 'names')[0];
                                $terms = get_terms($taxonomy_name);
                                foreach ($terms as $term) {
                                    ?>
                                    <li class="button-filter" id="<?php echo esc_attr($term->slug) . '_' . esc_attr($id); ?>"><a href="javascript:;"><?php echo esc_attr($term->name); ?></a></li>
                                    <?php
                                }
                                ?>
                            </ul>
                        </div>
                    <?php endif; ?>
                    <div class="our-gallery-slick-img">
                        <ul class="slick-slider slick-our-gallery">
                            <?php
                            while ($wp_query->have_posts()) : $wp_query->the_post();
                                $post_id = get_the_ID();
                                $campaign = new Charitable_Campaign($post_id);
                                $raisedpercent = $campaign->get_percent_donated();
                                $percent = str_replace('%', '', $raisedpercent);
                                $currency_helper = charitable_get_currency_helper();

                                $thumb_id = get_post_thumbnail_id($post_id);
                                $alt = get_post_meta($thumb_id, '_wp_attachment_image_alt', true);
                                $url = wp_get_attachment_url($thumb_id);
                                $image = sympathy_image_resize($url, 480, 322, true);

                                $term_list = wp_get_post_terms($post_id, $taxonomy_name);
                                ?>

                                <li class="filter-all_<?php echo esc_attr($id); ?> <?php
                                foreach ($term_list as $term) {
                                    echo 'filter-' . esc_attr($term->slug) . '_' . esc_attr($id) . ' ';
                                }
                                ?>">
                                    <div class="box">
                                        <div class="box-img char-box-show-more spt-hv-scale-img">
                                            <?php
                                            if (!empty($image)) {
                                                ?>
                                                <img src="<?php echo esc_url($image); ?>" alt="<?php if (count($alt)) echo esc_attr($alt); ?>">
                                                <?php
                                            }else {
                                                ?>
                                                <img src="<?php echo esc_url($url); ?>" alt="<?php if (count($alt)) echo esc_attr($alt); ?>">
                                                <?php
                                            }
                                            ?>
                                            <div class="show-more char-bg-primary clearfix">
                                                <a href="<?php echo get_permalink(); ?>"><i class="fa fa-link" aria-hidden="true"></i><?php echo esc_html__('Show more', 'sympathy'); ?></a>
                                                <ul>
                                                    <li><a href="javascript:void(0)" class="sympathy-post-like" data-id="<?php echo get_the_ID(); ?>"><i class="<?php echo!isset($_COOKIE['sympathy_post_like_' . get_the_ID()]) ? 'fa fa-heart-o' : 'fa fa-heart'; ?>" aria-hidden="true"></i></a></li>
                                                    <li><a href="<?php the_post_thumbnail_url('full'); ?>"  class="sympathy-popup-image"><i class="fa fa-arrows-alt" aria-hidden="true"></i></a></li>
                                                </ul>
                                            </div>
                                        </div>
                                    </div>
                                </li>
                                <?php
                            endwhile;
                            ?> 
                        </ul>
                    </div>
                    <div class="clearboth"></div>
                </div>
                <script type="text/javascript">
                    jQuery(function () {
                        jQuery('a.sympathy-popup-image').fancybox({
                            'transitionIn': 'elastic',
                            'transitionOut': 'elastic',
                            'speedIn': 600,
                            'speedOut': 200,
                            'overlayShow': false
                        });

                        if (jQuery(window).width() < 601) {
                            jQuery('#gallery-slider-<?php echo esc_attr($id); ?> .spt-filter-wrap .spt-grid-filter-inphone a').on('click', function () {
                                jQuery('#gallery-slider-<?php echo esc_attr($id); ?> .spt-filter-category').slideToggle().toggleClass('active');
                            });
                            jQuery('#gallery-slider-<?php echo esc_attr($id); ?> .spt-filter-wrap .spt-filter-category a').on('click', function () {
                                var txt = jQuery(this).text();
                                jQuery('#gallery-slider-<?php echo esc_attr($id); ?> .spt-filter-wrap .spt-grid-filter-inphone a span').text(txt);
                                jQuery('#gallery-slider-<?php echo esc_attr($id); ?> .spt-filter-category').slideUp().removeClass('active');
                            });
                        }

                        var filtered = false;
                        jQuery('#gallery-slider-<?php echo esc_attr($id); ?> .spt-filter-category .button-filter').on('click', function () {
                            var filtername = jQuery(this).attr('id');
                            if (filtered === false) {
                                jQuery('#gallery-slider-<?php echo esc_attr($id); ?> .slick-our-gallery').slick('slickUnfilter');
                                jQuery('#gallery-slider-<?php echo esc_attr($id); ?> .slick-our-gallery').slick('slickFilter', '.filter-' + filtername);
                                jQuery('#gallery-slider-<?php echo esc_attr($id); ?> .spt-filter-category .button-filter').attr('class', 'button-filter');
                                jQuery(this).attr('class', 'active button-filter');
                                return false;
                            } else {
                                jQuery('#gallery-slider-<?php echo esc_attr($id); ?> .slick-our-gallery').slick('slickUnfilter');
                                jQuery('#gallery-slider-<?php echo esc_attr($id); ?> .slick-our-gallery').slick('slickFilter', '.filter-' + filtername);
                                jQuery('#gallery-slider-<?php echo esc_attr($id); ?> .slick-our-gallery').slickGoTo(0);
                                jQuery('#gallery-slider-<?php echo esc_attr($id); ?> .spt-filter-category .button-filter').attr('class', 'button-filter');
                                jQuery(this).attr('class', 'active button-filter');
                                filtered = false;
                                return false;
                            }
                        });

                    });
                </script>
            </div>
            <?php
        endif;
        wp_reset_postdata();
        return ob_get_clean();
    }

endif;

add_action('vc_before_init', 'sympathy_vc_gallery_slider');
if (!function_exists('sympathy_vc_gallery_slider')) {

    function sympathy_vc_gallery_slider() {
        $postTypes = get_post_types(array());
        $postTypesList = array();
        $excludedPostTypes = array(
            'revision',
            'nav_menu_item',
            'vc_grid_item',
            'custom_css',
            'customize_changeset',
            'product_variation',
            'shop_order',
            'shop_order_refund',
            'shop_coupon',
            'shop_webhook',
            'nf_sub',
            'attachment',
        );

        if (is_array($postTypes) && !empty($postTypes)) {
            foreach ($postTypes as $postType) {
                if (!in_array($postType, $excludedPostTypes)) {
                    $label = ucfirst($postType);
                    $postTypesList[] = array(
                        $postType,
                        $label,
                    );
                }
            }
        }
        $postTypesList[] = array(
            'custom',
            __('Custom query', 'sympathy'),
        );
        $postTypesList[] = array(
            'ids',
            __('List of IDs', 'sympathy'),
        );
        vc_map(array(
            "name" => esc_html__("Gallery Slider Image", 'sympathy'),
            "base" => "sympathy_gallery_slider",
            "class" => "sympathy_gallery_slider",
            "category" => esc_html__('QTCThemes', 'sympathy'),
            'icon' => get_template_directory_uri() . "/images/icon/img.png",
            'description' => esc_html__('Adds images in slider in many styles.', 'sympathy'),
            "params" => array(
                array(
                    "type" => "dropdown",
                    "heading" => esc_html__("Data source", "sympathy"),
                    'param_name' => 'post_type',
                    'value' => $postTypesList,
                    'save_always' => true,
                    'description' => __('Select content type for your slider.', 'sympathy'),
                    'admin_label' => true,
                ),
                array(
                    "type" => "number",
                    "heading" => esc_html__("Post Count", 'sympathy'),
                    "param_name" => "posts_per_page",
                    "value" => -1,
                    "description" => esc_html__("-1: show all, limit 100", 'sympathy')
                ),
                array(
                    'type' => 'exploded_textarea',
                    'heading' => __('Categories', 'sympathy'),
                    'param_name' => 'categories',
                    'description' => __('Enter categories by names to narrow output (Note: only listed categories will be displayed, divide categories with linebreak (Enter)).', 'sympathy'),
                    "dependency" => array(
                        'element' => "post_type",
                        'value' => array(
                            'campaign'
                        )
                    )
                ),
                array(
                    "heading" => esc_html__("Order", 'sympathy'),
                    "description" => esc_html__("Designates the ascending or descending order of the 'orderby' parameter.", 'sympathy'),
                    "param_name" => "order",
                    "value" => array(
                        esc_html__("ASC (ascending order)", 'sympathy') => "ASC",
                        esc_html__("DESC (descending order)", 'sympathy') => "DESC"
                    ),
                    "type" => "dropdown"
                ),
                array(
                    "heading" => esc_html__("Orderby", 'sympathy'),
                    "description" => esc_html__("Sorts retrieved gallery items by parameter.", 'sympathy'),
                    "param_name" => "orderby",
                    "value" => array(
                        esc_html__("Date", 'sympathy') => "date",
                        esc_html__("post id", 'sympathy') => "id",
                        esc_html__("title", 'sympathy') => "title",
                        esc_html__("No order", 'sympathy') => "none"
                    ),
                    "type" => "dropdown"
                ),
                array(
                    "type" => "checkbox",
                    "class" => "",
                    "heading" => esc_html__("Disble Filter", 'sympathy'),
                    "param_name" => "disable_filter",
                    "value" => "",
                    "description" => esc_html__("Please using checkbox to disable a filter.", 'sympathy')
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Extra class name", "sympathy"),
                    "param_name" => "el_class",
                    "value" => "",
                    "description" => esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in Custom CSS Shortcode or Masterkey Custom CSS option.", "sympathy")
                ),
            )
        ));
    }

}