<?php
/**
 * Contact Info
 *
 * @package Sympathy
 * @author QTC Media
 * @link http://qtcmedia.com
 */
/* -------------------Contact Info---------------------- */
sympathy_insert_shortcode('sympathy_icon_contact', 'sympathy_icon_contact_template');
if (!function_exists('sympathy_icon_contact_template')):

    function sympathy_icon_contact_template($atts, $content) {
        global $sympathy_smof_data;
        extract(shortcode_atts(array(
            'selected_team_icon' => '',
            'title' => '',
            'font_size' => '14px',
            'el_class' => '',
            'margin_bottom' => '10px',
            'color' => '',
            'el_class' => ''
                        ), $atts));
        $rand_grid = rand(5, 12315646131);
        $id = md5(time() . ' ' . $rand_grid);
        ob_start();
        ?>
        <style type="text/css">
            .contact-info-<?php echo esc_attr($id); ?> .fa, .contact-info-<?php echo esc_attr($id); ?> .crt-titles, .contact-info-<?php echo esc_attr($id); ?> .crt-desc {
                font-size: <?php echo esc_attr($font_size); ?>;
                color: <?php echo esc_attr($color); ?>;
            }
            .contact-info-<?php echo esc_attr($id); ?> .crt-desc a{
                color: <?php echo esc_attr($color); ?>;
            }
            .contact-info-<?php echo esc_attr($id); ?>{
                margin-bottom: <?php echo esc_attr($margin_bottom); ?>;
            }
        <?php if (empty($selected_team_icon)): ?>
            .widget_contact_info .crt-content{
                padding-left:0px;
            }
        <?php endif;?>
        </style>
        <div class="widget_contact_info contact-info-<?php echo esc_attr($id); ?> sympathy-contact-info-shortcode a_margin-bottom-20 <?php echo esc_attr($el_class); ?>" >   
        <?php if(!empty( $selected_team_icon)): ?>
            <div class="crt-icon">
                <i class="fa <?php echo esc_attr($selected_team_icon); ?>" aria-hidden="true"></i>
            </div>
        <?php endif; ?>
            <div class="crt-content">
                <span class="crt-titles"><?php echo esc_attr($title); ?></span><br>
                <span class="crt-desc"><?php echo do_shortcode(strip_tags($content)); ?></span>
            </div>            
        </div>
        <?php
        return ob_get_clean();
    }

endif;

add_action('vc_before_init', 'sympathy_vc_icon_contact');
if (!function_exists('sympathy_vc_icon_contact')) {

    function sympathy_vc_icon_contact() {
        vc_map(array(
            "base" => "sympathy_icon_contact",
            "name" => esc_html__("Icon Contact", "sympathy"),
            "category" => esc_html__('QTCThemes', 'sympathy'),
            'icon' => get_template_directory_uri() . "/images/icon/plan.png",
            'description' => esc_html__('Adds icon contact info details.', 'sympathy'),
            "params" => array(
                array(
                    'type' => 'icon_manager',
                    'heading' => esc_html__('Select Icon', 'sympathy'),
                    'param_name' => 'selected_team_icon',
                    'value' => '',
                    'description' => esc_html__('Select icon from library.', 'sympathy'),
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Title", "sympathy"),
                    "param_name" => "title",
                    "value" => ""
                ),
                array(
                    "type" => "textarea_html",
                    "holder" => "div",
                    "heading" => esc_html__("Description", "sympathy"),
                    "param_name" => "content",
                    "value" => ""
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Font Size", "sympathy"),
                    "param_name" => "font_size",
                    "value" => "14px"
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Margin Bottom", "sympathy"),
                    "param_name" => "margin_bottom",
                    "value" => "10px",
                    "description" => esc_html__("", "sympathy"),
                ),
                array(
                    "type" => "colorpicker",
                    "heading" => esc_html__("Color", "sympathy"),
                    "param_name" => "color",
                    "value" => "",
                    "description" => esc_html__("", "sympathy"),
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Extra class name", "sympathy"),
                    "param_name" => "el_class",
                    "value" => "",
                    "description" => esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your CSS file.", "sympathy")
                )
            )
        ));
    }

} 