<?php
/**
 * Slideshow
 *
 * @package Sympathy
 * @author QTC Media
 * @link http://qtcmedia.com
 */
/* -------------------Slideshow---------------------- */
sympathy_insert_shortcode('sympathy_slide_show', 'sympathy_slide_show_template');

if (!function_exists('sympathy_slide_show_template')):

    function sympathy_slide_show_template($atts, $content) {
        global $sympathy_smof_data;
        extract(shortcode_atts(array(
            'images' => '',
            'video' => 'false',
            'link_video' => '',
            'bullets' => 'true',
            'img_size' => '',
            'auto' => 'false',
            'box_shadow' => 'false',
            'margin_bottom' => 20,
            'el_class' => '',
                        ), $atts));
        $rand_grid = rand(5, 12315646131);
        $id = md5(time() . ' ' . $rand_grid);
        ob_start();
        ?>
        <style type="text/css">
            .slide-show-<?php echo esc_attr($id); ?>{
                margin-bottom: <?php echo esc_attr($margin_bottom); ?>px;
                <?php if ($box_shadow == 'true') { ?>
                    box-shadow: 0px 0px 20px #f1f2f1;
                <?php } ?>
            }
            .slide-show-<?php echo esc_attr($id); ?> .slick-dots{
                background: #f1f2f1;
            }
            .crt-slider-show {
                width: 100%;
                margin: 0 auto;
            }

            .slick-slide {
                margin: 0px 20px;
            }

            .slick-slide img{
                margin: 0 auto
            }

            .slick-prev:before,
            .slick-next:before {
                color: black;
            }
            .slide-show-<?php echo esc_attr($id); ?>{
                margin-bottom: <?php echo esc_attr($margin_bottom); ?>px;
            }
        </style>
        <section class="slide-show-<?php echo esc_attr($id); ?> crt-regular-<?php echo esc_attr($id); ?> crt-slider-show <?php echo esc_attr($el_class); ?>">
            <?php
            $img_id = explode(',', $images);
            foreach ($img_id as $key => $value) {
                $image = wp_get_attachment_image_src($value, $img_size);
                $alt = get_post_meta($value, '_wp_attachment_image_alt', true);
                ?>
                <div>
                    <img src="<?php echo esc_url($image[0]); ?>" alt="<?php echo esc_attr($alt); ?>">
                </div>            
            <?php } ?>     
            <?php
            if ($video != 'false'):
                $custom_link = explode(',', $link_video);
                foreach ($custom_link as $key => $value) {
                    ?>
                    <div>
                        <?php echo do_shortcode('[video src="' . $value . '"]'); ?>
                    </div>
                    <?php
                }
            endif;
            ?>
        </section>
        <script type="text/javascript">
            jQuery(document).on('ready', function () {
                jQuery(".crt-regular-<?php echo esc_attr($id); ?>").slick({
                    infinite: true,
                    dots: <?php echo esc_attr($bullets); ?>,
                    arrows: false,
                    slidesToShow: 1,
                    autoplay: <?php echo esc_attr($auto); ?>,
                    autoplaySpeed: 2000,
                    slidesToScroll: 1,
                    responsive: [
                        {
                            breakpoint: 1024,
                            settings: {
                                slidesToShow: 3,
                                slidesToScroll: 3,
                                infinite: true,
                                dots: true
                            }
                        },
                        {
                            breakpoint: 600,
                            settings: {
                                slidesToShow: 2,
                                slidesToScroll: 2,
                                arrows: false,
                                dots: false
                            }
                        },
                        {
                            breakpoint: 480,
                            settings: {
                                slidesToShow: 1,
                                slidesToScroll: 1,
                                arrows: false,
                                dots: false
                            }
                        }
                    ]
                });
            });
        </script>
        <?php
        return ob_get_clean();
    }

endif;

add_action('vc_before_init', 'sympathy_vc_slide_show');
if (!function_exists('sympathy_vc_slide_show')) {

    function sympathy_vc_slide_show() {
        vc_map(array(
            "base" => "sympathy_slide_show",
            "name" => esc_html__("Slide Show", "sympathy"),
            "category" => esc_html__('QTCThemes', 'sympathy'),
            'icon' => get_template_directory_uri() . "/images/icon/icon_video.png",
            'description' => esc_html__('Adds image/video to slide.', 'sympathy'),
            "params" => array(
                array(
                    'type' => 'attach_images',
                    'heading' => esc_html__('Images', 'sympathy'),
                    'param_name' => 'images',
                    'value' => '',
                    'description' => esc_html__('Select images from media library.', 'sympathy'),
                ),
                array(
                    'type' => 'textfield',
                    'heading' => esc_html__('Image size', 'sympathy'),
                    'param_name' => 'img_size',
                    'value' => 'thumbnail',
                    'description' => esc_html__('Enter image size (Example: "thumbnail", "medium", "large", "full" or other sizes defined by theme). Alternatively enter size in pixels (Example: 200x100 (Width x Height)).', 'sympathy'),
                ),
                array(
                    "heading" => esc_html__("Add video to slide", 'sympathy'),
                    "param_name" => "video",
                    "value" => array(
                        esc_html__("No", 'sympathy') => "false",
                        esc_html__("Yes", 'sympathy') => "true"
                    ),
                    "type" => "dropdown",
                ),
                array(
                    'type' => 'textfield',
                    'heading' => __('Video link', 'sympathy'),
                    'param_name' => 'link_video',
                    'value' => 'https://vimeo.com/51589652',
                    'admin_label' => true,
                    "description" => __("Please add your links, If you use custom links the lightbox will be converted to external links. separate your URLs with comma ','", "sympathy"),
                    "dependency" => array(
                        'element' => "video",
                        'value' => array(
                            'true',
                        )
                    )
                ),
                array(
                    "heading" => esc_html__("Auto Play", 'sympathy'),
                    "param_name" => "auto",
                    "value" => array(
                        esc_html__("No", 'sympathy') => "false",
                        esc_html__("Yes", 'sympathy') => "true"
                    ),
                    "type" => "dropdown"
                ),
                array(
                    "heading" => esc_html__("Enable / Disable Bullets", 'sympathy'),
                    "param_name" => "bullets",
                    "value" => array(
                        esc_html__("Enable", 'sympathy') => "true",
                        esc_html__("Disable", 'sympathy') => "false",
                    ),
                    "type" => "dropdown"
                ),
                array(
                    "heading" => esc_html__("Box Shadow", 'sympathy'),
                    "param_name" => "box_shadow",
                    "value" => array(
                        esc_html__("Enable", 'sympathy') => "true",
                        esc_html__("Disable", 'sympathy') => "false",
                    ),
                    "type" => "dropdown"
                ),
                array(
                    "type" => "number",
                    "heading" => esc_html__("Margin Bottom (px)", "sympathy"),
                    "param_name" => "margin_bottom",
                    "value" => 20,
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Extra class name", "sympathy"),
                    "param_name" => "el_class",
                    "value" => "",
                    "description" => esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in Custom CSS Shortcode or Masterkey Custom CSS option.", "sympathy")
                )
            )
        ));
    }

} 