<?php
/**
 * Social Network
 *
 * @package Sympathy
 * @author QTC Media
 * @link http://qtcmedia.com
 */
/* -------------------Social Network---------------------- */
sympathy_insert_shortcode('sympathy_social_network', 'sympathy_social_network_template');

if (!function_exists('sympathy_social_network_template')):

    function sympathy_social_network_template($atts, $content) {
        global $sympathy_smof_data;
        extract(shortcode_atts(array(
            'el_class' => '',
            'font_size' => '14px',
            'align' => 'left',
            'margin_bottom' => '20px',
            'margin_icon' => "4px",
            'icon_color' => '#ccc',
            'icon_hover_color' => '#eee',
            'facebook' => "",
            'twitter' => "",
            'rss' => "",
            'dribbble' => "",
            'digg' => "",
            'pinterest' => "",
            'flickr' => "",
            'google_plus' => "",
            'skype' => "",
            'linkedin' => "",
            'youtube' => "",
            'last_fm' => "",
            'stumble_upon' => "",
            'tumblr' => "",
            'vimeo' => "",
            'wordpress' => "",
            'instagram' => "",
            'soundcloud' => "",
            'yelp' => "",
            'reddit' => "",
            'renren' => "",
            'vk' => "",
            'wechat' => "",
            'weibo' => "",
            'xing' => "",
            'whatsapp' => "",
                        ), $atts));
        $class[] = $el_class;
        $rand_grid = rand(5, 12315646131);
        $id = md5(time() . ' ' . $rand_grid);
        $sites = array(
            'facebook-official' => $facebook,
            'twitter-square' => $twitter,
            'xing-square' => $xing,
            'rss-square' => $rss,
            'dribbble' => $dribbble,
            'instagram' => $instagram,
            'soundcloud' => $soundcloud,
            'digg' => $digg,
            'pinterest-square' => $pinterest,
            'flickr' => $flickr,
            'google-plus-square' => $google_plus,
            'skype' => $skype,
            'linkedin-square' => $linkedin,
            'youtube-square' => $youtube,
            'lastfm-square' => $last_fm,
            'stumbleupon' => $stumble_upon,
            'tumblr-square' => $tumblr,
            'vimeo-square' => $vimeo,
            'wordpress' => $wordpress,
            'yelp' => $yelp,
            'reddit-square' => $reddit,
            'whatsapp' => $whatsapp,
            'weibo' => $weibo,
            'wechat' => $wechat,
            'vk' => $vk,
            'renren' => $renren
        );
        ob_start();
        ?>
        <style type="text/css">
            .social-align-<?php echo esc_attr($align); ?>{
                text-align: <?php echo esc_attr($align); ?>;
            }
            #social-networks-<?php echo esc_attr($id); ?>.s_social ul li a i{
                font-size: <?php echo esc_attr($font_size); ?>;
                color:<?php echo esc_attr($icon_color); ?>;
            }
            #social-networks-<?php echo esc_attr($id); ?>.s_social ul li a:hover i{
                color:<?php echo esc_attr($icon_hover_color); ?>;
                    -webkit-transition: all .35s ease;
                -o-transition: all .35s ease;
                transition: all .35s ease;
            }
            #social-networks-<?php echo esc_attr($id); ?>.s_social ul li a{
                margin-right: <?php echo esc_attr($margin_icon); ?>;
            }
            #social-networks-<?php echo esc_attr($id); ?>.a_margin-10-0{
                margin-bottom: <?php echo esc_attr($margin_bottom); ?>;
            }
        </style>
        <div id="social-networks-<?php echo esc_attr($id); ?>" class="mk-social-network-shortcode a_padding-0 a_margin-10-0 s_social a_m_list-reset social-align-<?php echo esc_attr($align); ?> <?php echo esc_attr($font_size); ?> <?php echo esc_attr($el_class); ?>">
            <ul class="a_margin-0 a_padding-0 a_list-style-none">
                <?php
                foreach ($sites as $name => $link) {
                    echo!empty($link) ? '<li><a target="_blank" class="' . esc_attr($name) . '-hover c_" href="' . esc_url($link) . '"><i class="fa fa-' . esc_attr($name) . '  c_"></i></a></li>' : '';
                }
                ?>
            </ul>
        </div>
        <?php
        return ob_get_clean();
    }

endif;

add_action('vc_before_init', 'sympathy_vc_social_network');
if (!function_exists('sympathy_vc_social_network')) {

    function sympathy_vc_social_network() {
        vc_map(array(
            "base" => "sympathy_social_network",
            "name" => esc_html__("Social Network", "sympathy"),
            "category" => esc_html__('QTCThemes', 'sympathy'),
            'icon' => get_template_directory_uri() . "/images/icon/share.png",
            'description' => esc_html__('Adds social network icons.', 'sympathy'),
            "params" => array(
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Font Size", "sympathy"),
                    "param_name" => "font_size",
                    "value" => "14px"
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Margin", "sympathy"),
                    "param_name" => "margin_icon",
                    "value" => "4px",
                    "description" => esc_html__("The distance between icons. This margin will be applied to all directions.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Margin Bottom", "sympathy"),
                    "param_name" => "margin_bottom",
                    "value" => "20px",
                    "description" => esc_html__("", "sympathy")
                ),
                array(
                    "type" => "colorpicker",
                    "heading" => esc_html__("Icons Color", "sympathy"),
                    "param_name" => "icon_color",
                    "value" => "#ccc",
                    "description" => esc_html__("(default: #ccc)", "sympathy")
                ),
                array(
                    "type" => "colorpicker",
                    "heading" => esc_html__("Icons Hover Color", "sympathy"),
                    "param_name" => "icon_hover_color",
                    "value" => "#eee",
                    "description" => esc_html__("(default: #eee)", "sympathy")
                ),
                array(
                    "type" => "dropdown",
                    "heading" => esc_html__("Icons Align", "sympathy"),
                    "param_name" => "align",
                    "value" => array(
                        esc_html__('Left', "sympathy") => "left",
                        esc_html__('Right', "sympathy") => "right",
                        esc_html__('Center', "sympathy") => "center"
                    ),
                    "description" => esc_html__("", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Facebook URL", "sympathy"),
                    "param_name" => "facebook",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Twitter URL", "sympathy"),
                    "param_name" => "twitter",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("RSS URL", "sympathy"),
                    "param_name" => "rss",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Dribbble URL", "sympathy"),
                    "param_name" => "dribbble",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Digg URL", "sympathy"),
                    "param_name" => "digg",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Pinterest URL", "sympathy"),
                    "param_name" => "pinterest",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Flickr URL", "sympathy"),
                    "param_name" => "flickr",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Google Plus URL", "sympathy"),
                    "param_name" => "google_plus",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Skype URL", "sympathy"),
                    "param_name" => "skype",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL including 'http://'' for profile page or 'skype:USERNAME?call' for direct call (replace USERNAME with your own). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Instagram URL", "sympathy"),
                    "param_name" => "instagram",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Linkedin URL", "sympathy"),
                    "param_name" => "linkedin",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Youtube URL", "sympathy"),
                    "param_name" => "youtube",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Last-fm URL", "sympathy"),
                    "param_name" => "last_fm",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Stumble-upon URL", "sympathy"),
                    "param_name" => "stumble_upon",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Sound Cloud URL", "sympathy"),
                    "param_name" => "soundcloud",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Tumblr URL", "sympathy"),
                    "param_name" => "tumblr",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Vimeo URL", "sympathy"),
                    "param_name" => "vimeo",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("WordPress URL", "sympathy"),
                    "param_name" => "wordpress",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Yelp URL", "sympathy"),
                    "param_name" => "yelp",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Reddit URL", "sympathy"),
                    "param_name" => "reddit",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Xing URL", "sympathy"),
                    "param_name" => "xing",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy"),
                    "dependency" => array(
                        'element' => "style",
                        'value' => array(
                            'rounded',
                            'circle',
                        )
                    )
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Renren URL", "sympathy"),
                    "param_name" => "renren",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("VK.com URL", "sympathy"),
                    "param_name" => "vk",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Wechat URL", "sympathy"),
                    "param_name" => "wechat",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Weibo URL", "sympathy"),
                    "param_name" => "weibo",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Whatsapp URL", "sympathy"),
                    "param_name" => "whatsapp",
                    "value" => "",
                    "description" => esc_html__("Enter the full URL of your corresponding social network. Include (http://). If left blank, this social network icon will not be shown.", "sympathy")
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Extra class name", "sympathy"),
                    "param_name" => "el_class",
                    "value" => "",
                    "description" => esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in Custom CSS Shortcode or Masterkey Custom CSS option.", "sympathy")
                )
            )
        ));
    }

} 