<?php
/**
 * Video
 *
 * @package Sympathy
 * @author QTC Media
 * @link http://qtcmedia.com
 */
/* -------------------Slideshow---------------------- */

sympathy_insert_shortcode('sympathy_video', 'sympathy_video_template');

if (!function_exists('sympathy_video_template')):

    function sympathy_video_template($atts, $content) {
        global $sympathy_smof_data;
        extract(shortcode_atts(array(
            'image' => '',
            'link_video' => 'false',
            'title' => '',
            'el_class' => '',
           ), $atts));
        $img = '';
        ob_start();
        ?>
        <div class="sympathy-video-img">
            <?php 
            if($image){
                echo wp_get_attachment_image($image,'large');
            }
            ?>
            <div class="sympathy-icon-video-play"><a href="<?php echo ($link_video)?esc_url($link_video):'#'?>" class="html5lightbox" title="<?php echo esc_attr($title); ?>"><img src="<?php echo SYMPATHY_THEME_URI.'/assets/images/icon-play.png';?>" alt="Play"></a></div>
        </div>
        <?php
        return ob_get_clean();
    }

endif;

add_action('vc_before_init', 'sympathy_vc_video_show');
if (!function_exists('sympathy_vc_video_show')) {

    function sympathy_vc_video_show() {
        vc_map(array(
            "base" => "sympathy_video",
            "name" => esc_html__("Sympathy Video", "sympathy"),
            "category" => esc_html__('QTCThemes', 'sympathy'),
            'icon' => get_template_directory_uri() . "/images/icon/icon_video.png",
            'description' => esc_html__('Adds image/video to slide.', 'sympathy'),
            'as_parent' => array(
                'only' => 'vc_tta_section',
            ),
            "params" => array(
                array(
                    'type' => 'attach_image',
                    'heading' => esc_html__('Images', 'sympathy'),
                    'param_name' => 'image',
                    'value' => '',
                    'description' => esc_html__('Select images from media library.', 'sympathy'),
                ),
                array(
                    'type' => 'textfield',
                    'heading' => __('Video link', 'sympathy'),
                    'param_name' => 'link_video',
                    'value' => '',
                    'admin_label' => true,
                    "description" => __("Please add your links. EXP: https://vimeo.com/51589652 ','", "sympathy"),
                ),
                array(
                    'type' => 'textfield',
                    'heading' => __('Title Video', 'sympathy'),
                    'param_name' => 'title',
                    'value' => '',
                    'admin_label' => true,
                    "description" => __("Enter title this video','", "sympathy"),
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Extra class name", "sympathy"),
                    "param_name" => "el_class",
                    "value" => "",
                    "description" => esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in Custom CSS Shortcode or Masterkey Custom CSS option.", "sympathy")
                )
            )
        ));
    }

} 