<?php
/**
 * Video Wrrap
 *
 * @package Sympathy
 * @author QTC Media
 * @link http://qtcmedia.com
 */
/* -------------------Slideshow---------------------- */

sympathy_insert_shortcode('sympathy_video_slider', 'sympathy_video_slider_template');

if (!function_exists('sympathy_video_slider_template')):

    function sympathy_video_slider_template($atts, $content) {
        global $sympathy_smof_data;
        extract(shortcode_atts(array(
            'title' => '',
            'el_class' => '',
            'css' => '',
            'video' => 'false',
            'bullets' => 'true',
            'img_size' => '',
            'auto' => 'false',
            'box_shadow' => 'false',
            'margin_bottom' => 20,
                        ), $atts));
        $rand_grid = rand(5, 12315646131);
        $id = md5(time() . ' ' . $rand_grid);
        wp_enqueue_script('html5lightbox.js');
        ob_start();
        ?>
        <style type="text/css">
            .slide-show-<?php echo esc_attr($id); ?>{
                margin-bottom: <?php echo esc_attr($margin_bottom); ?>px;
                <?php if ($box_shadow == 'true') { ?>
                    box-shadow: 0px 0px 20px #f1f2f1;
                <?php } ?>
            }
            .crt-slider-show {
                width: 100%;
                margin: 0 auto;
            }
            .slick-slide img{
                margin: 0 auto
            }
            .slick-prev:before,
            .slick-next:before {
                color: black;
            }
            .slide-show-<?php echo esc_attr($id); ?> .slick-dots{
                background: #f1f2f1;
            }
            .slide-show-<?php echo esc_attr($id); ?>{
                margin-bottom: <?php echo esc_attr($margin_bottom); ?>px;
            }
        </style>
        <section class="qtc-slider-video slide-show-<?php echo esc_attr($id); ?> crt-regular-<?php echo esc_attr($id); ?> crt-slider-show <?php echo esc_attr($el_class); ?>">
            <?php
            echo wpb_js_remove_wpautop($content);
            ?>
        </section>
        <script type="text/javascript">
            jQuery(document).on('ready', function () {
                jQuery(".crt-regular-<?php echo esc_attr($id); ?>").slick({
                    infinite: true,
                    dots: <?php echo esc_attr($bullets); ?>,
                    arrows: false,
                    slidesToShow: 1,
                    autoplay: <?php echo esc_attr($auto); ?>,
                    autoplaySpeed: 2000,
                    slidesToScroll: 1
                });
            });
        </script>
        <?php
        return ob_get_clean();
    }

endif;

add_action('vc_before_init', 'sympathy_video_slider_show');
if (!function_exists('sympathy_video_slider_show')) {

    function sympathy_video_slider_show() {
        vc_map(array(
            "base" => "sympathy_video_slider",
            "name" => esc_html__("Video Slider", "sympathy"),
            "category" => esc_html__('QTCThemes', 'sympathy'),
            'icon' => get_template_directory_uri() . "/images/icon/icon_video.png",
            'description' => esc_html__('Adds image/video to slide.', 'sympathy'),
            'is_container' => true,
            'show_settings_on_create' => false,
            'as_parent' => array(
                'only' => 'vc_tta_section',
            ),
            "as_child" => array('only' => 'sympathy_video'),
            "params" => array(
                array(
                    'type' => 'textfield',
                    'param_name' => 'title',
                    'heading' => __('Widget title', 'sympathy'),
                    'description' => __('Enter text used as widget title (Note: located above content element).', 'sympathy'),
                ),
                array(
                    "heading" => esc_html__("Add video to slide", 'sympathy'),
                    "description" => esc_html__("", 'sympathy'),
                    "param_name" => "video",
                    "value" => array(
                        esc_html__("No", 'sympathy') => "false",
                        esc_html__("Yes", 'sympathy') => "true"
                    ),
                    "type" => "dropdown",
                ),
                array(
                    "heading" => esc_html__("Auto Play", 'sympathy'),
                    "param_name" => "auto",
                    "value" => array(
                        esc_html__("No", 'sympathy') => "false",
                        esc_html__("Yes", 'sympathy') => "true"
                    ),
                    "type" => "dropdown"
                ),
                array(
                    "heading" => esc_html__("Enable / Disable Bullets", 'sympathy'),
                    "param_name" => "bullets",
                    "value" => array(
                        esc_html__("Enable", 'sympathy') => "true",
                        esc_html__("Disable", 'sympathy') => "false",
                    ),
                    "type" => "dropdown"
                ),
                array(
                    "heading" => esc_html__("Box Shadow", 'sympathy'),
                    "param_name" => "box_shadow",
                    "value" => array(
                        esc_html__("Enable", 'sympathy') => "true",
                        esc_html__("Disable", 'sympathy') => "false",
                    ),
                    "type" => "dropdown"
                ),
                array(
                    "type" => "number",
                    "heading" => esc_html__("Margin Bottom (px)", "sympathy"),
                    "param_name" => "margin_bottom",
                    "value" => 20,
                ),
                vc_map_add_css_animation(),
                array(
                    'type' => 'textfield',
                    'heading' => __('Extra class name', 'sympathy'),
                    'param_name' => 'el_class',
                    'description' => __('If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'sympathy'),
                ),
                array(
                    'type' => 'css_editor',
                    'heading' => __('CSS box', 'sympathy'),
                    'param_name' => 'css',
                    'group' => __('Design Options', 'sympathy'),
                ),
            ),
            'js_view' => 'VcBackendTtaAccordionView',
            'custom_markup' => '
                    <div class="vc_tta-container" data-vc-action="collapseAll">
                            <div class="vc_general vc_tta vc_tta-accordion vc_tta-color-backend-accordion-white vc_tta-style-flat vc_tta-shape-rounded vc_tta-o-shape-group vc_tta-controls-align-left vc_tta-gap-2">
                               <div class="vc_tta-panels vc_clearfix {{container-class}}">
                                  {{ content }}
                                  <div class="vc_tta-panel vc_tta-section-append">
                                     <div class="vc_tta-panel-heading">
                                        <h4 class="vc_tta-panel-title vc_tta-controls-icon-position-left">
                                           <a href="javascript:;" aria-expanded="false" class="vc_tta-backend-add-control">
                                               <span class="vc_tta-title-text">' . __('Add Section', 'sympathy') . '</span>
                                                <i class="vc_tta-controls-icon vc_tta-controls-icon-plus"></i>
                                                            </a>
                                        </h4>
                                     </div>
                                  </div>
                               </div>
                            </div>
                    </div>',
            'default_content' => '[vc_tta_section title="' . sprintf('%s %d', __('Section', 'sympathy'), 1) . '"][/vc_tta_section][vc_tta_section title="' . sprintf('%s %d', __('Section', 'sympathy'), 2) . '"][/vc_tta_section]',
        ));
    }

} 